/* original parser id follows */
/* yysccsid[] = "@(#)yaccpar	1.9 (Berkeley) 02/21/93" */
/* (use YYMAJOR/YYMINOR for ifdefs dependent on parser version) */

#define YYBYACC 1
#define YYMAJOR 2
#define YYMINOR 0
#define YYPATCH 20230521

#define YYEMPTY        (-1)
#define yyclearin      (yychar = YYEMPTY)
#define yyerrok        (yyerrflag = 0)
#define YYRECOVERING() (yyerrflag != 0)
#define YYENOMEM       (-2)
#define YYEOF          0
#undef YYBTYACC
#define YYBTYACC 0
#define YYDEBUGSTR YYPREFIX "debug"
#define YYPREFIX "yy"

#define YYPURE 0

#line 2 "wrapit.y"
#include <stdio.h>
#include <ncarg/hlu/hlu.h>
#include <ncarg/hlu/NresDB.h>
#include <ncarg/ncl/defs.h>
#include <ncarg/ncl/NclDataDefs.h>
#include "WSymbol.h"
#include "fstrings.h"
extern char *yytext;
void yyerror(const char *);
extern char* gettxt();
typedef struct wrap_src_node_list {
	void *node;
	struct wrap_src_node_list *next;
}WrapSrcListNode;

typedef struct int_list {
	int val;
	struct int_list *next;
}IntList;
extern char *wrapname;
int nargs;
int w_nargs;
extern WWrapRec *current;

WParamLoc* theparam = NULL;

WrapSrcListNode *WMakeListNode(void) 
{
	WrapSrcListNode *tmp = (WrapSrcListNode*)malloc(sizeof(WrapSrcListNode));
	tmp->next = NULL;
	tmp->node = NULL;
	return(tmp);
}

extern WCentry *WNewVDef(char* ,int , int ,char* ,int);
extern WGetArgValue *WNewArgVal();
extern WCallRec* WNewCallRec(char* ,int );
extern WSrcList* WNewAdditionalSrc(char*,int);
extern WParamLoc* NewParamLoc(NclSymbol*);

extern void DoTotal(NclSymbol*);
extern void DoDimsizes(NclSymbol*);


int FType(char *fname) {
	switch(fname[0]) {
	case 'i':
	case 'I':
	case 'j':
	case 'J':
	case 'k':
	case 'K':
	case 'l':
	case 'L':
	case 'm':
	case 'M':
	case 'n':
	case 'N':
		return(NCL_int);
	default:
		return(NCL_float);
	}
}
char *NType(int datatype) {
	switch(datatype) {
	case NCL_byte:
		return("NCL_byte");
	case NCL_char:
		return("NCL_char");
	case NCL_float:
		return("NCL_float");
	case NCL_double:
		return("NCL_double");
	case NCL_int:
		return("NCL_int");
	case NCL_short:
		return("NCL_short");
	case NCL_long: 
		return("NCL_long");
	case NCL_none:
		return("NclANY");
	case NCL_string: 
		return("NrmQuark");
	default:
		return("void");
	}
}
char *CType(int datatype) {
	switch(datatype) {
	case NCL_byte:
		return("byte");
	case NCL_char:
		return("char");
	case NCL_float:
		return("float");
	case NCL_double:
		return("double");
	case NCL_int:
		return("int");
	case NCL_short:
		return("short");
	case NCL_long: 
		return("long");
	case NCL_string: 
		return("NrmQuark");
	case NCL_none:
	default:
		return("void");
	}
}


#ifdef YYSTYPE
#undef  YYSTYPE_IS_DECLARED
#define YYSTYPE_IS_DECLARED 1
#endif
#ifndef YYSTYPE_IS_DECLARED
#define YYSTYPE_IS_DECLARED 1
#line 115 "wrapit.y"
typedef union YYSTYPE {
	int integer;
	char *str;
	struct _NclSymbol *sym;
	struct _DimVal *dim;
	struct _FTypeVal *ftyp;
	void *src_node;
	WParamLoc  *ploc;
	WDSpecList *dsp;
	WModList *mod;
	struct int_list *ilist;
	struct wrap_src_node_list *list;
} YYSTYPE;
#endif /* !YYSTYPE_IS_DECLARED */
#line 158 "y.tab.c"

/* compatibility with bison */
#ifdef YYPARSE_PARAM
/* compatibility with FreeBSD */
# ifdef YYPARSE_PARAM_TYPE
#  define YYPARSE_DECL() yyparse(YYPARSE_PARAM_TYPE YYPARSE_PARAM)
# else
#  define YYPARSE_DECL() yyparse(void *YYPARSE_PARAM)
# endif
#else
# define YYPARSE_DECL() yyparse(void)
#endif

/* Parameters sent to lex. */
#ifdef YYLEX_PARAM
# define YYLEX_DECL() yylex(void *YYLEX_PARAM)
# define YYLEX yylex(YYLEX_PARAM)
#else
# define YYLEX_DECL() yylex(void)
# define YYLEX yylex()
#endif

#if !(defined(yylex) || defined(YYSTATE))
int YYLEX_DECL();
#endif

/* Parameters sent to yyerror. */
#ifndef YYERROR_DECL
#define YYERROR_DECL() yyerror(const char *s)
#endif
#ifndef YYERROR_CALL
#define YYERROR_CALL(msg) yyerror(msg)
#endif

extern int YYPARSE_DECL();

#define EOLN 257
#define ENDOFIF 258
#define INT 259
#define BYTE1 260
#define INTEGER2 261
#define INTEGER4 262
#define INTEGER8 263
#define REAL4 264
#define REAL8 265
#define DIMENSION 266
#define DATA 267
#define SAVE 268
#define COMMON 269
#define IMPLICIT 270
#define WPARAM 271
#define FNAME 272
#define UNDEF 273
#define SUBROUTINE 274
#define FUNCTION 275
#define NEW 276
#define IN 277
#define OUT 278
#define INOUT 279
#define TYPE 280
#define NOMISSING 281
#define DIMSIZES 282
#define PROCEDURE 283
#define MISSING 284
#define RETURN 285
#define REAL 286
#define PRECISION 287
#define INTEGER 288
#define FLOAT 289
#define LONG 290
#define DOUBLE 291
#define BYTE 292
#define CHARACTER 293
#define STRNG 294
#define SHORT 295
#define LOGICAL 296
#define FARG 297
#define FUNC 298
#define SUBR 299
#define PROC 300
#define XFARG 301
#define CVAR 302
#define YYERRCODE 256
typedef int YYINT;
static const YYINT yylhs[] = {                           -1,
    0,    0,   12,   12,   12,   30,   12,    2,    2,    1,
    1,   31,   31,   32,   32,   22,   22,   29,   29,    6,
    6,    8,    8,    8,    8,    8,    8,    8,    8,    8,
    8,    8,    8,    8,    8,    8,    8,   23,   23,    3,
    3,    3,    3,    3,    3,    3,   24,   24,    7,    7,
    7,    9,    9,   14,   14,   14,   13,   13,   13,   13,
   25,   25,    4,    4,    4,    4,   28,   28,   28,   28,
    5,    5,    5,    5,    5,    5,    5,    5,    5,   27,
   27,   15,   33,   15,   21,   21,   21,   21,   26,   26,
   34,   16,   20,   20,   20,   20,   20,   10,   10,   10,
   10,   10,   10,   10,   10,   10,   10,   11,   11,   11,
   11,   11,   11,   11,   11,   19,   19,   18,   18,   17,
   17,   17,   17,   17,   17,   17,   17,   17,   17,   17,
};
static const YYINT yylen[] = {                            2,
    2,    3,    2,    2,    3,    0,    4,    8,    7,    6,
    5,    0,    1,    1,    2,    1,    3,    0,    1,    3,
    4,    1,    1,    1,    2,    1,    1,    1,    1,    1,
    3,    1,    5,    3,    3,    3,    3,    1,    3,    1,
    3,    5,    4,    4,    1,    4,    1,    3,    1,    1,
    1,    0,    1,    0,    1,    1,    7,    7,    5,    6,
    1,    3,    1,    3,    2,    4,    3,    3,    4,    4,
    1,    1,    1,    1,    1,    1,    1,    1,    1,    2,
    3,    1,    0,    3,    3,    4,    4,    7,    2,    3,
    0,    3,    5,    3,    4,    4,    7,    1,    1,    2,
    2,    5,    3,    4,    4,    7,    3,    1,    2,    2,
    5,    1,    2,    2,    5,    0,    1,    2,    3,    3,
    3,    1,    1,    1,    3,    3,    4,    4,    2,    2,
};
static const YYINT yydefred[] = {                         0,
   30,   27,   29,   28,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,   53,    0,    0,    0,    0,    0,
   25,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    1,    0,   37,   35,   34,    0,   31,   36,    2,    0,
    0,    0,   38,    0,    0,    0,    0,    5,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,   14,
   20,    0,    7,    0,    0,   55,   56,    0,   11,    0,
    0,   33,   21,   51,   50,   49,   47,    0,    0,    0,
    0,   41,   39,   15,    0,    0,    0,   17,   10,    0,
   46,   44,   43,    0,    0,    0,   61,    0,    0,    0,
    0,    0,   48,   42,    0,    0,    0,    0,    0,    0,
   59,    0,    9,    0,    0,    0,    0,   82,   91,   83,
    0,   73,   71,   72,   75,   77,   76,   78,   74,   79,
   64,    0,    0,    0,    0,   62,    0,    0,    8,    0,
    0,   80,    0,    0,    0,   68,   67,   66,    0,    0,
    0,    0,    0,    0,    0,   85,    0,    0,   94,    0,
    0,    0,   92,   84,   81,   69,   70,   89,    0,    0,
   87,    0,   95,    0,    0,    0,  122,  123,  124,    0,
    0,    0,  118,    0,   90,    0,    0,    0,    0,   98,
   99,    0,    0,    0,    0,    0,    0,  119,    0,    0,
    0,  100,    0,    0,    0,    0,    0,  108,  112,  125,
  126,  121,  120,   88,   97,    0,    0,    0,  107,  103,
  127,  128,    0,    0,  109,  113,    0,    0,  104,    0,
    0,  102,    0,    0,    0,    0,  111,  115,  106,
};
#if defined(YYDESTRUCT_CALL) || defined(YYSTYPE_TOSTRING)
static const YYINT yystos[] = {                           0,
  266,  267,  268,  270,  274,  286,  288,  291,  292,  293,
  296,  304,  305,  306,  312,  313,  316,  273,   42,   42,
  287,   42,   42,   42,  316,  310,  312,  333,  333,  275,
  258,   40,  259,  259,  259,   40,  259,  259,  258,  312,
  273,  297,  307,  327,  334,  275,  283,  317,  273,   41,
  273,  326,   42,  327,   40,   47,   40,   42,   44,  257,
  335,  336,  317,  273,  273,   42,  259,  318,  335,   44,
   41,   41,  335,   42,  259,  297,  311,  328,  259,  328,
   40,  259,  307,  257,   40,   40,   40,  326,  335,   44,
   41,   47,   41,   42,   41,  273,  308,  329,   41,  329,
   41,  326,  311,   41,  257,   58,   91,  332,   44,   41,
  257,   41,  335,   41,  285,  301,  319,  320,  324,  325,
  331,  288,  289,  290,  291,  292,  293,  294,  295,  296,
  309,   42,  259,   58,   91,  308,  257,  257,  335,   58,
   58,  257,  338,  337,  319,   93,   93,  309,   42,  259,
  331,  320,  330,   47,   35,  271,   47,   35,  271,  276,
   58,  322,  323,  323,  257,   93,   93,  257,  320,  271,
  271,  271,  271,   61,   64,   38,  277,  278,  279,  280,
  282,  284,  321,   58,  257,   91,   91,   47,   35,  259,
  271,  314,  273,  273,   61,   61,   61,  321,  259,  259,
  271,  271,   44,   61,   61,   47,   35,  271,  301,  309,
  315,  315,  315,   93,   93,   91,   47,   35,  259,  271,
  315,  315,  271,  301,  271,  301,  259,  271,  271,   91,
   91,   93,   91,  259,  259,  259,   93,   93,   93,
};
#endif /* YYDESTRUCT_CALL || YYSTYPE_TOSTRING */
static const YYINT yydgoto[] = {                         12,
   13,   14,   43,   97,  131,   26,   77,   15,   16,  192,
  211,   17,   48,   68,  117,  118,  183,  162,  163,  119,
  120,   52,   44,   78,   98,  153,  121,  108,   28,   45,
   61,   62,  144,  143,
};
static const YYINT yysindex[] = {                      -160,
    0,    0,    0,    0, -233,    4,   18, -204,   46,   51,
   58, -160, -129, -129,    0, -174, -139,   83, -135, -125,
    0, -101,  -30,  -99, -128, -129, -220,    0, -236, -108,
    0,  -22,    0,    0,    0,  124,    0,    0,    0, -220,
   11,  114,    0,  -19, -236, -103, -100,    0,  -37,  -70,
  144,  148,  149,  -19,  -33,  -68,  -33,  -10, -220,    0,
    0,  -65,    0,  153,  154,    0,    0,  155,    0,  -77,
  -70,    0,    0,    0,    0,    0,    0,  103,  150,  107,
  156,    0,    0,    0,   -8,   -5,   -4,    0,    0,  -33,
    0,    0,    0,  158,  -57,  -17,    0,  108,  -56,  109,
  -70,  161,    0,    0, -156, -110,  -25,  -15,  -69,  -54,
    0,  -52,    0,  -70,  151,  152,  -49,    0,    0,    0,
 -156,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,  118,  119, -110,   -7,    0, -156,  -88,    0,  -21,
  -31,    0,  157,  157,  -43,    0,    0,    0,  123,  125,
 -156,  -40,  -88,  -48,  -47,    0,  -46,  -39,    0,  159,
  -36,  163,    0,    0,    0,    0,    0,    0,   24,  142,
    0,  188,    0,  -32,    9,   10,    0,    0,    0,  223,
  229,  231,    0,  -36,    0,   36,   40,   29,   32,    0,
    0,  260,  245,  247,  -35,  -34,  -34,    0,  216,  220,
  225,    0,  -24,  -34,  -34, -249, -247,    0,    0,    0,
    0,    0,    0,    0,    0,   55,   47,   48,    0,    0,
    0,    0,  226,  230,    0,    0,  227,  232,    0,   63,
   65,    0,   66,  233,  234,  235,    0,    0,    0,
};
static const YYINT yyrindex[] = {                        54,
    0,    0,    0,    0,    0, -225, -195,    0, -170, -162,
 -157,   54, -216, -216,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0, -214,    0, -213,   72,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    5,   19,    0, -202,    0,    0,    0,    0,  291, -202,
  292,    0,    0, -202,    0,    0,    0,    0,    0,    0,
    0, -171,    0,    0,    0,    0,    0,    0,    0,    0,
 -202,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,  130,    0,    0,    0,    0,
 -202,    0,    0,    0,    0,    0,    0,  131,    0,    0,
    0,    0,    0, -202,    0,    0,    0,    0,    0,    0,
   74,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,   77,   77,    0,    0,    0,    0,    0,    0,
   78,    0,   79,    0,    0,    0,    0,    0,    0,    0,
    0,   81,    0,    0,    0,    0,    0,    0,    0,  -51,
    0,  -50,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,  -29,  -27,   13,    0,    0,    0,    0,    0,    0,
  -38,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,   17,   21,    0,    0,    0,  -26,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,
};
#if YYBTYACC
static const YYINT yycindex[] = {                         0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,
};
#endif
static const YYINT yygindex[] = {                         0,
    0,    0,  276,  236, -113,    0,  249,  129,    0,    0,
  -28,  328,  296,    0,  -94,    8,  160,    0,  198,    0,
    0,   22,  303,  289,  261,    0,  211,    0,  335,    0,
  -16,    0,    0,    0,
};
#define YYTABLESIZE 349
static const YYINT yytable[] = {                        207,
  207,  176,  189,  158,   66,  101,   86,   96,   74,   36,
  218,  206,  206,  155,  188,  157,  132,  105,   50,  101,
  148,  223,  217,  225,   59,  154,  145,  175,   93,   81,
  129,  105,   95,   69,  149,   99,  101,   73,   46,   18,
  106,   18,  134,   19,    4,   19,   47,   26,   45,   26,
   55,  224,   41,  226,   89,   12,  145,   56,   18,   20,
   19,    6,   40,   12,   12,   12,   18,   12,   19,    6,
  130,   26,   12,  107,  110,  135,   42,   23,  114,   23,
   12,  210,   21,   12,  113,   12,   13,   22,   12,   12,
   12,   88,   23,   12,   13,   13,   13,  139,   13,   24,
   30,   23,   22,   13,   22,    1,    2,    3,  102,    4,
   32,   13,   32,    5,   13,   24,   13,   24,   31,   13,
   13,   13,   32,   33,   13,    6,   22,    7,  115,   39,
    8,    9,   10,   34,   32,   11,    1,    2,    3,   24,
    4,   27,   27,   91,  116,  152,   90,   93,  110,  112,
   90,  109,  109,   57,   40,   58,    6,   35,    7,   38,
  169,    8,    9,   10,   49,   53,   11,  212,  213,   64,
   63,   65,   65,   63,   65,  221,  222,  122,  123,  124,
  125,  126,  127,  128,  129,  130,   60,   70,   71,   72,
   79,   84,   85,   86,   87,   51,   92,   94,  104,  105,
  111,  114,  137,   96,  138,   86,   96,  142,  140,  141,
  146,  147,  116,  165,  161,  166,  168,  167,  101,  174,
  184,   67,  170,  171,  172,   75,  190,   93,   37,  129,
  105,  173,  186,  133,  219,  208,  208,   60,  191,  159,
  177,  178,  179,  180,  160,  181,  220,  182,   82,  156,
   51,  150,  122,  123,  124,  125,  126,  127,  128,  129,
  130,   45,   45,   76,   96,  209,  209,   96,   51,  130,
   45,   45,   45,  110,   45,   40,   40,  114,  187,   45,
  185,  193,  194,  195,   40,   40,   40,   45,   40,  196,
   45,  197,   45,   40,  199,   45,   45,   45,  200,  201,
   45,   40,  202,  203,   40,  204,   40,  205,  214,   40,
   40,   40,  215,  227,   40,  216,  230,  228,  229,  232,
  231,  234,  233,  235,  236,  237,  238,  239,   52,    3,
   54,   60,   16,  116,   83,   58,   57,  117,  103,   25,
   63,  164,   54,  198,  136,   80,  100,  151,   29,
};
static const YYINT yycheck[] = {                         35,
   35,   38,   35,   35,   42,   44,   58,   58,   42,   40,
   35,   47,   47,   35,   47,   47,   42,   44,   41,   58,
  134,  271,   47,  271,   44,   47,  121,   64,   58,   40,
   58,   58,   41,   50,   42,   41,   41,   54,  275,  273,
   58,  258,   58,  258,  258,   42,  283,  273,   44,  275,
   40,  301,  273,  301,   71,  258,  151,   47,  275,   42,
  275,  275,   44,  266,  267,  268,  283,  270,  283,  283,
   58,  297,  275,   91,   58,   91,  297,  273,   58,  275,
  283,  195,  287,  286,  101,  288,  258,   42,  291,  292,
  293,   70,   42,  296,  266,  267,  268,  114,  270,   42,
  275,  297,  273,  275,  275,  266,  267,  268,   87,  270,
  273,  283,  275,  274,  286,  273,  288,  275,  258,  291,
  292,  293,   40,  259,  296,  286,  297,  288,  285,  258,
  291,  292,  293,  259,  297,  296,  266,  267,  268,  297,
  270,   13,   14,   41,  301,  138,   44,   41,   41,   41,
   44,   44,   44,   40,   26,   42,  286,  259,  288,  259,
  153,  291,  292,  293,  273,   42,  296,  196,  197,  273,
   41,   41,  273,   44,   44,  204,  205,  288,  289,  290,
  291,  292,  293,  294,  295,  296,  257,   44,   41,   41,
  259,  257,   40,   40,   40,  273,   47,   42,   41,  257,
  257,   41,  257,  273,  257,  257,  257,  257,   58,   58,
   93,   93,  301,  257,   58,   93,  257,   93,  257,   61,
   58,  259,  271,  271,  271,  259,  259,  257,  259,  257,
  257,  271,   91,  259,  259,  271,  271,  257,  271,  271,
  277,  278,  279,  280,  276,  282,  271,  284,  259,  271,
  273,  259,  288,  289,  290,  291,  292,  293,  294,  295,
  296,  257,  258,  297,  273,  301,  301,  273,  273,  257,
  266,  267,  268,  257,  270,  257,  258,  257,   91,  275,
  257,  273,  273,   61,  266,  267,  268,  283,  270,   61,
  286,   61,  288,  275,  259,  291,  292,  293,  259,  271,
  296,  283,  271,   44,  286,   61,  288,   61,   93,  291,
  292,  293,   93,  259,  296,   91,   91,  271,  271,   93,
   91,  259,   91,  259,  259,   93,   93,   93,  275,  258,
   40,  258,   41,  257,   59,  258,  258,  257,   90,   12,
   45,  144,   40,  184,  109,   57,   86,  137,   14,
};
#if YYBTYACC
static const YYINT yyctable[] = {                        -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
};
#endif
#define YYFINAL 12
#ifndef YYDEBUG
#define YYDEBUG 0
#endif
#define YYMAXTOKEN 302
#define YYUNDFTOKEN 339
#define YYTRANSLATE(a) ((a) > YYMAXTOKEN ? YYUNDFTOKEN : (a))
#if YYDEBUG
static const char *const yyname[] = {

"$end",0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
"'#'",0,0,"'&'",0,"'('","')'","'*'",0,"','",0,0,"'/'",0,0,0,0,0,0,0,0,0,0,"':'",
0,0,"'='",0,0,"'@'",0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,"'['",0,
"']'","'^'",0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
0,0,0,0,0,0,0,"error","EOLN","ENDOFIF","INT","BYTE1","INTEGER2","INTEGER4",
"INTEGER8","REAL4","REAL8","DIMENSION","DATA","SAVE","COMMON","IMPLICIT",
"WPARAM","FNAME","UNDEF","SUBROUTINE","FUNCTION","NEW","IN","OUT","INOUT",
"TYPE","NOMISSING","DIMSIZES","PROCEDURE","MISSING","RETURN","REAL","PRECISION",
"INTEGER","FLOAT","LONG","DOUBLE","BYTE","CHARACTER","STRNG","SHORT","LOGICAL",
"FARG","FUNC","SUBR","PROC","XFARG","CVAR","$accept","interface_list",
"subroutine_def","function_def","param_def","declaration","datatype",
"data_defs","dim","ftype","otyp","dspec_list","vspec","interface",
"wrap_interface","len","farg_map","normal_param","mod","mods_list","omods",
"param_loc","rparam","arg_list","name_list","dim_list","arg_dec_list",
"parg_map_list","farg_map_list","dim_size_list","odata_defs","$$1","oEOLN_list",
"EOLN_list","$$2","$$3","illegal-symbol",
};
static const char *const yyrule[] = {
"$accept : interface_list",
"interface_list : interface ENDOFIF",
"interface_list : interface_list interface ENDOFIF",
"interface : function_def odata_defs",
"interface : subroutine_def odata_defs",
"interface : function_def odata_defs wrap_interface",
"$$1 :",
"interface : subroutine_def odata_defs $$1 wrap_interface",
"function_def : otyp FUNCTION UNDEF len '(' arg_list ')' oEOLN_list",
"function_def : otyp FUNCTION UNDEF len '(' ')' oEOLN_list",
"subroutine_def : SUBROUTINE UNDEF '(' arg_list ')' oEOLN_list",
"subroutine_def : SUBROUTINE UNDEF '(' ')' oEOLN_list",
"oEOLN_list :",
"oEOLN_list : EOLN_list",
"EOLN_list : EOLN",
"EOLN_list : EOLN_list EOLN",
"arg_list : UNDEF",
"arg_list : UNDEF ',' arg_list",
"odata_defs :",
"odata_defs : data_defs",
"data_defs : ftype name_list oEOLN_list",
"data_defs : data_defs ftype name_list oEOLN_list",
"ftype : BYTE",
"ftype : INTEGER",
"ftype : LOGICAL",
"ftype : DOUBLE PRECISION",
"ftype : REAL",
"ftype : DATA",
"ftype : IMPLICIT",
"ftype : SAVE",
"ftype : DIMENSION",
"ftype : CHARACTER '*' INT",
"ftype : CHARACTER",
"ftype : CHARACTER '*' '(' '*' ')'",
"ftype : BYTE '*' INT",
"ftype : INTEGER '*' INT",
"ftype : LOGICAL '*' INT",
"ftype : REAL '*' INT",
"name_list : param_def",
"name_list : name_list ',' param_def",
"param_def : FARG",
"param_def : FARG '*' INT",
"param_def : FARG '*' '(' '*' ')'",
"param_def : FARG '(' dim_list ')'",
"param_def : UNDEF '/' INT '/'",
"param_def : UNDEF",
"param_def : UNDEF '(' dim_list ')'",
"dim_list : dim",
"dim_list : dim_list ',' dim",
"dim : FARG",
"dim : INT",
"dim : '*'",
"otyp :",
"otyp : ftype",
"len :",
"len : '*'",
"len : INT",
"wrap_interface : PROCEDURE UNDEF '(' arg_dec_list ')' EOLN parg_map_list",
"wrap_interface : FUNCTION UNDEF '(' arg_dec_list ')' EOLN farg_map_list",
"wrap_interface : PROCEDURE UNDEF '(' ')' EOLN",
"wrap_interface : FUNCTION UNDEF '(' ')' EOLN farg_map_list",
"arg_dec_list : declaration",
"arg_dec_list : arg_dec_list ',' declaration",
"declaration : UNDEF",
"declaration : UNDEF ':' datatype",
"declaration : UNDEF dim_size_list",
"declaration : UNDEF dim_size_list ':' datatype",
"dim_size_list : '[' INT ']'",
"dim_size_list : '[' '*' ']'",
"dim_size_list : dim_size_list '[' '*' ']'",
"dim_size_list : dim_size_list '[' INT ']'",
"datatype : FLOAT",
"datatype : LONG",
"datatype : INTEGER",
"datatype : SHORT",
"datatype : DOUBLE",
"datatype : CHARACTER",
"datatype : BYTE",
"datatype : STRNG",
"datatype : LOGICAL",
"farg_map_list : farg_map EOLN",
"farg_map_list : farg_map_list farg_map EOLN",
"farg_map : normal_param",
"$$2 :",
"farg_map : rparam $$2 omods",
"rparam : RETURN ':' WPARAM",
"rparam : RETURN ':' '/' WPARAM",
"rparam : RETURN ':' '#' WPARAM",
"rparam : RETURN ':' '/' WPARAM '[' INT ']'",
"parg_map_list : normal_param EOLN",
"parg_map_list : parg_map_list normal_param EOLN",
"$$3 :",
"normal_param : param_loc $$3 omods",
"param_loc : XFARG ':' NEW '=' dspec_list",
"param_loc : XFARG ':' WPARAM",
"param_loc : XFARG ':' '#' WPARAM",
"param_loc : XFARG ':' '/' WPARAM",
"param_loc : XFARG ':' '/' WPARAM '[' INT ']'",
"dspec_list : INT",
"dspec_list : WPARAM",
"dspec_list : '#' WPARAM",
"dspec_list : '/' WPARAM",
"dspec_list : '/' WPARAM '[' INT ']'",
"dspec_list : dspec_list ',' WPARAM",
"dspec_list : dspec_list ',' '#' WPARAM",
"dspec_list : dspec_list ',' '/' WPARAM",
"dspec_list : dspec_list ',' '/' WPARAM '[' INT ']'",
"dspec_list : dspec_list ',' INT",
"vspec : WPARAM",
"vspec : '#' WPARAM",
"vspec : '/' WPARAM",
"vspec : '/' WPARAM '[' INT ']'",
"vspec : XFARG",
"vspec : '#' XFARG",
"vspec : '/' XFARG",
"vspec : '/' XFARG '[' INT ']'",
"omods :",
"omods : mods_list",
"mods_list : ':' mod",
"mods_list : mods_list ':' mod",
"mod : MISSING '=' vspec",
"mod : DIMSIZES '=' vspec",
"mod : IN",
"mod : OUT",
"mod : INOUT",
"mod : TYPE '=' datatype",
"mod : TYPE '=' vspec",
"mod : '@' UNDEF '=' vspec",
"mod : '&' UNDEF '=' vspec",
"mod : '@' UNDEF",
"mod : '&' UNDEF",

};
#endif

#if YYDEBUG
int      yydebug;
#endif

int      yyerrflag;
int      yychar;
YYSTYPE  yyval;
YYSTYPE  yylval;
int      yynerrs;

#if defined(YYLTYPE) || defined(YYLTYPE_IS_DECLARED)
YYLTYPE  yyloc; /* position returned by actions */
YYLTYPE  yylloc; /* position from the lexer */
#endif

#if defined(YYLTYPE) || defined(YYLTYPE_IS_DECLARED)
#ifndef YYLLOC_DEFAULT
#define YYLLOC_DEFAULT(loc, rhs, n) \
do \
{ \
    if (n == 0) \
    { \
        (loc).first_line   = YYRHSLOC(rhs, 0).last_line; \
        (loc).first_column = YYRHSLOC(rhs, 0).last_column; \
        (loc).last_line    = YYRHSLOC(rhs, 0).last_line; \
        (loc).last_column  = YYRHSLOC(rhs, 0).last_column; \
    } \
    else \
    { \
        (loc).first_line   = YYRHSLOC(rhs, 1).first_line; \
        (loc).first_column = YYRHSLOC(rhs, 1).first_column; \
        (loc).last_line    = YYRHSLOC(rhs, n).last_line; \
        (loc).last_column  = YYRHSLOC(rhs, n).last_column; \
    } \
} while (0)
#endif /* YYLLOC_DEFAULT */
#endif /* defined(YYLTYPE) || defined(YYLTYPE_IS_DECLARED) */
#if YYBTYACC

#ifndef YYLVQUEUEGROWTH
#define YYLVQUEUEGROWTH 32
#endif
#endif /* YYBTYACC */

/* define the initial stack-sizes */
#ifdef YYSTACKSIZE
#undef YYMAXDEPTH
#define YYMAXDEPTH  YYSTACKSIZE
#else
#ifdef YYMAXDEPTH
#define YYSTACKSIZE YYMAXDEPTH
#else
#define YYSTACKSIZE 10000
#define YYMAXDEPTH  10000
#endif
#endif

#ifndef YYINITSTACKSIZE
#define YYINITSTACKSIZE 200
#endif

typedef struct {
    unsigned stacksize;
    YYINT    *s_base;
    YYINT    *s_mark;
    YYINT    *s_last;
    YYSTYPE  *l_base;
    YYSTYPE  *l_mark;
#if defined(YYLTYPE) || defined(YYLTYPE_IS_DECLARED)
    YYLTYPE  *p_base;
    YYLTYPE  *p_mark;
#endif
} YYSTACKDATA;
#if YYBTYACC

struct YYParseState_s
{
    struct YYParseState_s *save;    /* Previously saved parser state */
    YYSTACKDATA            yystack; /* saved parser stack */
    int                    state;   /* saved parser state */
    int                    errflag; /* saved error recovery status */
    int                    lexeme;  /* saved index of the conflict lexeme in the lexical queue */
    YYINT                  ctry;    /* saved index in yyctable[] for this conflict */
};
typedef struct YYParseState_s YYParseState;
#endif /* YYBTYACC */
/* variables for the parser stack */
static YYSTACKDATA yystack;
#if YYBTYACC

/* Current parser state */
static YYParseState *yyps = 0;

/* yypath != NULL: do the full parse, starting at *yypath parser state. */
static YYParseState *yypath = 0;

/* Base of the lexical value queue */
static YYSTYPE *yylvals = 0;

/* Current position at lexical value queue */
static YYSTYPE *yylvp = 0;

/* End position of lexical value queue */
static YYSTYPE *yylve = 0;

/* The last allocated position at the lexical value queue */
static YYSTYPE *yylvlim = 0;

#if defined(YYLTYPE) || defined(YYLTYPE_IS_DECLARED)
/* Base of the lexical position queue */
static YYLTYPE *yylpsns = 0;

/* Current position at lexical position queue */
static YYLTYPE *yylpp = 0;

/* End position of lexical position queue */
static YYLTYPE *yylpe = 0;

/* The last allocated position at the lexical position queue */
static YYLTYPE *yylplim = 0;
#endif

/* Current position at lexical token queue */
static YYINT  *yylexp = 0;

static YYINT  *yylexemes = 0;
#endif /* YYBTYACC */
#line 2008 "wrapit.y"
void yyerror
#if __STDC__
(const char *s)
#else
(s)
	char *s;
#endif
{
	char error_buffer[1024];
	int i;

	
	fprintf(stderr,"A syntax error occurred while parsing: %s\n",yytext);
	exit(0);
}
#line 842 "y.tab.c"

/* For use in generated program */
#define yydepth (int)(yystack.s_mark - yystack.s_base)
#if YYBTYACC
#define yytrial (yyps->save)
#endif /* YYBTYACC */

#if YYDEBUG
#include <stdio.h>	/* needed for printf */
#endif

#include <stdlib.h>	/* needed for malloc, etc */
#include <string.h>	/* needed for memset */

/* allocate initial stack or double stack size, up to YYMAXDEPTH */
static int yygrowstack(YYSTACKDATA *data)
{
    int i;
    unsigned newsize;
    YYINT *newss;
    YYSTYPE *newvs;
#if defined(YYLTYPE) || defined(YYLTYPE_IS_DECLARED)
    YYLTYPE *newps;
#endif

    if ((newsize = data->stacksize) == 0)
        newsize = YYINITSTACKSIZE;
    else if (newsize >= YYMAXDEPTH)
        return YYENOMEM;
    else if ((newsize *= 2) > YYMAXDEPTH)
        newsize = YYMAXDEPTH;

    i = (int) (data->s_mark - data->s_base);
    newss = (YYINT *)realloc(data->s_base, newsize * sizeof(*newss));
    if (newss == 0)
        return YYENOMEM;

    data->s_base = newss;
    data->s_mark = newss + i;

    newvs = (YYSTYPE *)realloc(data->l_base, newsize * sizeof(*newvs));
    if (newvs == 0)
        return YYENOMEM;

    data->l_base = newvs;
    data->l_mark = newvs + i;

#if defined(YYLTYPE) || defined(YYLTYPE_IS_DECLARED)
    newps = (YYLTYPE *)realloc(data->p_base, newsize * sizeof(*newps));
    if (newps == 0)
        return YYENOMEM;

    data->p_base = newps;
    data->p_mark = newps + i;
#endif

    data->stacksize = newsize;
    data->s_last = data->s_base + newsize - 1;

#if YYDEBUG
    if (yydebug)
        fprintf(stderr, "%sdebug: stack size increased to %d\n", YYPREFIX, newsize);
#endif
    return 0;
}

#if YYPURE || defined(YY_NO_LEAKS)
static void yyfreestack(YYSTACKDATA *data)
{
    free(data->s_base);
    free(data->l_base);
#if defined(YYLTYPE) || defined(YYLTYPE_IS_DECLARED)
    free(data->p_base);
#endif
    memset(data, 0, sizeof(*data));
}
#else
#define yyfreestack(data) /* nothing */
#endif /* YYPURE || defined(YY_NO_LEAKS) */
#if YYBTYACC

static YYParseState *
yyNewState(unsigned size)
{
    YYParseState *p = (YYParseState *) malloc(sizeof(YYParseState));
    if (p == NULL) return NULL;

    p->yystack.stacksize = size;
    if (size == 0)
    {
        p->yystack.s_base = NULL;
        p->yystack.l_base = NULL;
#if defined(YYLTYPE) || defined(YYLTYPE_IS_DECLARED)
        p->yystack.p_base = NULL;
#endif
        return p;
    }
    p->yystack.s_base    = (YYINT *) malloc(size * sizeof(YYINT));
    if (p->yystack.s_base == NULL) return NULL;
    p->yystack.l_base    = (YYSTYPE *) malloc(size * sizeof(YYSTYPE));
    if (p->yystack.l_base == NULL) return NULL;
    memset(p->yystack.l_base, 0, size * sizeof(YYSTYPE));
#if defined(YYLTYPE) || defined(YYLTYPE_IS_DECLARED)
    p->yystack.p_base    = (YYLTYPE *) malloc(size * sizeof(YYLTYPE));
    if (p->yystack.p_base == NULL) return NULL;
    memset(p->yystack.p_base, 0, size * sizeof(YYLTYPE));
#endif

    return p;
}

static void
yyFreeState(YYParseState *p)
{
    yyfreestack(&p->yystack);
    free(p);
}
#endif /* YYBTYACC */

#define YYABORT  goto yyabort
#define YYREJECT goto yyabort
#define YYACCEPT goto yyaccept
#define YYERROR  goto yyerrlab
#if YYBTYACC
#define YYVALID        do { if (yyps->save)            goto yyvalid; } while(0)
#define YYVALID_NESTED do { if (yyps->save && \
                                yyps->save->save == 0) goto yyvalid; } while(0)
#endif /* YYBTYACC */

int
YYPARSE_DECL()
{
    int yym, yyn, yystate, yyresult;
#if YYBTYACC
    int yynewerrflag;
    YYParseState *yyerrctx = NULL;
#endif /* YYBTYACC */
#if defined(YYLTYPE) || defined(YYLTYPE_IS_DECLARED)
    YYLTYPE  yyerror_loc_range[3]; /* position of error start/end (0 unused) */
#endif
#if YYDEBUG
    const char *yys;

    if ((yys = getenv("YYDEBUG")) != 0)
    {
        yyn = *yys;
        if (yyn >= '0' && yyn <= '9')
            yydebug = yyn - '0';
    }
    if (yydebug)
        fprintf(stderr, "%sdebug[<# of symbols on state stack>]\n", YYPREFIX);
#endif
#if defined(YYLTYPE) || defined(YYLTYPE_IS_DECLARED)
    memset(yyerror_loc_range, 0, sizeof(yyerror_loc_range));
#endif

#if YYBTYACC
    yyps = yyNewState(0); if (yyps == 0) goto yyenomem;
    yyps->save = 0;
#endif /* YYBTYACC */
    yym = 0;
    /* yyn is set below */
    yynerrs = 0;
    yyerrflag = 0;
    yychar = YYEMPTY;
    yystate = 0;

#if YYPURE
    memset(&yystack, 0, sizeof(yystack));
#endif

    if (yystack.s_base == NULL && yygrowstack(&yystack) == YYENOMEM) goto yyoverflow;
    yystack.s_mark = yystack.s_base;
    yystack.l_mark = yystack.l_base;
#if defined(YYLTYPE) || defined(YYLTYPE_IS_DECLARED)
    yystack.p_mark = yystack.p_base;
#endif
    yystate = 0;
    *yystack.s_mark = 0;

yyloop:
    if ((yyn = yydefred[yystate]) != 0) goto yyreduce;
    if (yychar < 0)
    {
#if YYBTYACC
        do {
        if (yylvp < yylve)
        {
            /* we're currently re-reading tokens */
            yylval = *yylvp++;
#if defined(YYLTYPE) || defined(YYLTYPE_IS_DECLARED)
            yylloc = *yylpp++;
#endif
            yychar = *yylexp++;
            break;
        }
        if (yyps->save)
        {
            /* in trial mode; save scanner results for future parse attempts */
            if (yylvp == yylvlim)
            {   /* Enlarge lexical value queue */
                size_t p = (size_t) (yylvp - yylvals);
                size_t s = (size_t) (yylvlim - yylvals);

                s += YYLVQUEUEGROWTH;
                if ((yylexemes = (YYINT *)realloc(yylexemes, s * sizeof(YYINT))) == NULL) goto yyenomem;
                if ((yylvals   = (YYSTYPE *)realloc(yylvals, s * sizeof(YYSTYPE))) == NULL) goto yyenomem;
#if defined(YYLTYPE) || defined(YYLTYPE_IS_DECLARED)
                if ((yylpsns   = (YYLTYPE *)realloc(yylpsns, s * sizeof(YYLTYPE))) == NULL) goto yyenomem;
#endif
                yylvp   = yylve = yylvals + p;
                yylvlim = yylvals + s;
#if defined(YYLTYPE) || defined(YYLTYPE_IS_DECLARED)
                yylpp   = yylpe = yylpsns + p;
                yylplim = yylpsns + s;
#endif
                yylexp  = yylexemes + p;
            }
            *yylexp = (YYINT) YYLEX;
            *yylvp++ = yylval;
            yylve++;
#if defined(YYLTYPE) || defined(YYLTYPE_IS_DECLARED)
            *yylpp++ = yylloc;
            yylpe++;
#endif
            yychar = *yylexp++;
            break;
        }
        /* normal operation, no conflict encountered */
#endif /* YYBTYACC */
        yychar = YYLEX;
#if YYBTYACC
        } while (0);
#endif /* YYBTYACC */
        if (yychar < 0) yychar = YYEOF;
#if YYDEBUG
        if (yydebug)
        {
            if ((yys = yyname[YYTRANSLATE(yychar)]) == NULL) yys = yyname[YYUNDFTOKEN];
            fprintf(stderr, "%s[%d]: state %d, reading token %d (%s)",
                            YYDEBUGSTR, yydepth, yystate, yychar, yys);
#ifdef YYSTYPE_TOSTRING
#if YYBTYACC
            if (!yytrial)
#endif /* YYBTYACC */
                fprintf(stderr, " <%s>", YYSTYPE_TOSTRING(yychar, yylval));
#endif
            fputc('\n', stderr);
        }
#endif
    }
#if YYBTYACC

    /* Do we have a conflict? */
    if (((yyn = yycindex[yystate]) != 0) && (yyn += yychar) >= 0 &&
        yyn <= YYTABLESIZE && yycheck[yyn] == (YYINT) yychar)
    {
        YYINT ctry;

        if (yypath)
        {
            YYParseState *save;
#if YYDEBUG
            if (yydebug)
                fprintf(stderr, "%s[%d]: CONFLICT in state %d: following successful trial parse\n",
                                YYDEBUGSTR, yydepth, yystate);
#endif
            /* Switch to the next conflict context */
            save = yypath;
            yypath = save->save;
            save->save = NULL;
            ctry = save->ctry;
            if (save->state != yystate) YYABORT;
            yyFreeState(save);

        }
        else
        {

            /* Unresolved conflict - start/continue trial parse */
            YYParseState *save;
#if YYDEBUG
            if (yydebug)
            {
                fprintf(stderr, "%s[%d]: CONFLICT in state %d. ", YYDEBUGSTR, yydepth, yystate);
                if (yyps->save)
                    fputs("ALREADY in conflict, continuing trial parse.\n", stderr);
                else
                    fputs("Starting trial parse.\n", stderr);
            }
#endif
            save                  = yyNewState((unsigned)(yystack.s_mark - yystack.s_base + 1));
            if (save == NULL) goto yyenomem;
            save->save            = yyps->save;
            save->state           = yystate;
            save->errflag         = yyerrflag;
            save->yystack.s_mark  = save->yystack.s_base + (yystack.s_mark - yystack.s_base);
            memcpy (save->yystack.s_base, yystack.s_base, (size_t) (yystack.s_mark - yystack.s_base + 1) * sizeof(YYINT));
            save->yystack.l_mark  = save->yystack.l_base + (yystack.l_mark - yystack.l_base);
            memcpy (save->yystack.l_base, yystack.l_base, (size_t) (yystack.l_mark - yystack.l_base + 1) * sizeof(YYSTYPE));
#if defined(YYLTYPE) || defined(YYLTYPE_IS_DECLARED)
            save->yystack.p_mark  = save->yystack.p_base + (yystack.p_mark - yystack.p_base);
            memcpy (save->yystack.p_base, yystack.p_base, (size_t) (yystack.p_mark - yystack.p_base + 1) * sizeof(YYLTYPE));
#endif
            ctry                  = yytable[yyn];
            if (yyctable[ctry] == -1)
            {
#if YYDEBUG
                if (yydebug && yychar >= YYEOF)
                    fprintf(stderr, "%s[%d]: backtracking 1 token\n", YYDEBUGSTR, yydepth);
#endif
                ctry++;
            }
            save->ctry = ctry;
            if (yyps->save == NULL)
            {
                /* If this is a first conflict in the stack, start saving lexemes */
                if (!yylexemes)
                {
                    yylexemes = (YYINT *) malloc((YYLVQUEUEGROWTH) * sizeof(YYINT));
                    if (yylexemes == NULL) goto yyenomem;
                    yylvals   = (YYSTYPE *) malloc((YYLVQUEUEGROWTH) * sizeof(YYSTYPE));
                    if (yylvals == NULL) goto yyenomem;
                    yylvlim   = yylvals + YYLVQUEUEGROWTH;
#if defined(YYLTYPE) || defined(YYLTYPE_IS_DECLARED)
                    yylpsns   = (YYLTYPE *) malloc((YYLVQUEUEGROWTH) * sizeof(YYLTYPE));
                    if (yylpsns == NULL) goto yyenomem;
                    yylplim   = yylpsns + YYLVQUEUEGROWTH;
#endif
                }
                if (yylvp == yylve)
                {
                    yylvp  = yylve = yylvals;
#if defined(YYLTYPE) || defined(YYLTYPE_IS_DECLARED)
                    yylpp  = yylpe = yylpsns;
#endif
                    yylexp = yylexemes;
                    if (yychar >= YYEOF)
                    {
                        *yylve++ = yylval;
#if defined(YYLTYPE) || defined(YYLTYPE_IS_DECLARED)
                        *yylpe++ = yylloc;
#endif
                        *yylexp  = (YYINT) yychar;
                        yychar   = YYEMPTY;
                    }
                }
            }
            if (yychar >= YYEOF)
            {
                yylvp--;
#if defined(YYLTYPE) || defined(YYLTYPE_IS_DECLARED)
                yylpp--;
#endif
                yylexp--;
                yychar = YYEMPTY;
            }
            save->lexeme = (int) (yylvp - yylvals);
            yyps->save   = save;
        }
        if (yytable[yyn] == ctry)
        {
#if YYDEBUG
            if (yydebug)
                fprintf(stderr, "%s[%d]: state %d, shifting to state %d\n",
                                YYDEBUGSTR, yydepth, yystate, yyctable[ctry]);
#endif
            if (yychar < 0)
            {
                yylvp++;
#if defined(YYLTYPE) || defined(YYLTYPE_IS_DECLARED)
                yylpp++;
#endif
                yylexp++;
            }
            if (yystack.s_mark >= yystack.s_last && yygrowstack(&yystack) == YYENOMEM)
                goto yyoverflow;
            yystate = yyctable[ctry];
            *++yystack.s_mark = (YYINT) yystate;
            *++yystack.l_mark = yylval;
#if defined(YYLTYPE) || defined(YYLTYPE_IS_DECLARED)
            *++yystack.p_mark = yylloc;
#endif
            yychar  = YYEMPTY;
            if (yyerrflag > 0) --yyerrflag;
            goto yyloop;
        }
        else
        {
            yyn = yyctable[ctry];
            goto yyreduce;
        }
    } /* End of code dealing with conflicts */
#endif /* YYBTYACC */
    if (((yyn = yysindex[yystate]) != 0) && (yyn += yychar) >= 0 &&
            yyn <= YYTABLESIZE && yycheck[yyn] == (YYINT) yychar)
    {
#if YYDEBUG
        if (yydebug)
            fprintf(stderr, "%s[%d]: state %d, shifting to state %d\n",
                            YYDEBUGSTR, yydepth, yystate, yytable[yyn]);
#endif
        if (yystack.s_mark >= yystack.s_last && yygrowstack(&yystack) == YYENOMEM) goto yyoverflow;
        yystate = yytable[yyn];
        *++yystack.s_mark = yytable[yyn];
        *++yystack.l_mark = yylval;
#if defined(YYLTYPE) || defined(YYLTYPE_IS_DECLARED)
        *++yystack.p_mark = yylloc;
#endif
        yychar = YYEMPTY;
        if (yyerrflag > 0)  --yyerrflag;
        goto yyloop;
    }
    if (((yyn = yyrindex[yystate]) != 0) && (yyn += yychar) >= 0 &&
            yyn <= YYTABLESIZE && yycheck[yyn] == (YYINT) yychar)
    {
        yyn = yytable[yyn];
        goto yyreduce;
    }
    if (yyerrflag != 0) goto yyinrecovery;
#if YYBTYACC

    yynewerrflag = 1;
    goto yyerrhandler;
    goto yyerrlab; /* redundant goto avoids 'unused label' warning */

yyerrlab:
    /* explicit YYERROR from an action -- pop the rhs of the rule reduced
     * before looking for error recovery */
    yystack.s_mark -= yym;
    yystate = *yystack.s_mark;
    yystack.l_mark -= yym;
#if defined(YYLTYPE) || defined(YYLTYPE_IS_DECLARED)
    yystack.p_mark -= yym;
#endif

    yynewerrflag = 0;
yyerrhandler:
    while (yyps->save)
    {
        int ctry;
        YYParseState *save = yyps->save;
#if YYDEBUG
        if (yydebug)
            fprintf(stderr, "%s[%d]: ERROR in state %d, CONFLICT BACKTRACKING to state %d, %d tokens\n",
                            YYDEBUGSTR, yydepth, yystate, yyps->save->state,
                    (int)(yylvp - yylvals - yyps->save->lexeme));
#endif
        /* Memorize most forward-looking error state in case it's really an error. */
        if (yyerrctx == NULL || yyerrctx->lexeme < yylvp - yylvals)
        {
            /* Free old saved error context state */
            if (yyerrctx) yyFreeState(yyerrctx);
            /* Create and fill out new saved error context state */
            yyerrctx                 = yyNewState((unsigned)(yystack.s_mark - yystack.s_base + 1));
            if (yyerrctx == NULL) goto yyenomem;
            yyerrctx->save           = yyps->save;
            yyerrctx->state          = yystate;
            yyerrctx->errflag        = yyerrflag;
            yyerrctx->yystack.s_mark = yyerrctx->yystack.s_base + (yystack.s_mark - yystack.s_base);
            memcpy (yyerrctx->yystack.s_base, yystack.s_base, (size_t) (yystack.s_mark - yystack.s_base + 1) * sizeof(YYINT));
            yyerrctx->yystack.l_mark = yyerrctx->yystack.l_base + (yystack.l_mark - yystack.l_base);
            memcpy (yyerrctx->yystack.l_base, yystack.l_base, (size_t) (yystack.l_mark - yystack.l_base + 1) * sizeof(YYSTYPE));
#if defined(YYLTYPE) || defined(YYLTYPE_IS_DECLARED)
            yyerrctx->yystack.p_mark = yyerrctx->yystack.p_base + (yystack.p_mark - yystack.p_base);
            memcpy (yyerrctx->yystack.p_base, yystack.p_base, (size_t) (yystack.p_mark - yystack.p_base + 1) * sizeof(YYLTYPE));
#endif
            yyerrctx->lexeme         = (int) (yylvp - yylvals);
        }
        yylvp          = yylvals   + save->lexeme;
#if defined(YYLTYPE) || defined(YYLTYPE_IS_DECLARED)
        yylpp          = yylpsns   + save->lexeme;
#endif
        yylexp         = yylexemes + save->lexeme;
        yychar         = YYEMPTY;
        yystack.s_mark = yystack.s_base + (save->yystack.s_mark - save->yystack.s_base);
        memcpy (yystack.s_base, save->yystack.s_base, (size_t) (yystack.s_mark - yystack.s_base + 1) * sizeof(YYINT));
        yystack.l_mark = yystack.l_base + (save->yystack.l_mark - save->yystack.l_base);
        memcpy (yystack.l_base, save->yystack.l_base, (size_t) (yystack.l_mark - yystack.l_base + 1) * sizeof(YYSTYPE));
#if defined(YYLTYPE) || defined(YYLTYPE_IS_DECLARED)
        yystack.p_mark = yystack.p_base + (save->yystack.p_mark - save->yystack.p_base);
        memcpy (yystack.p_base, save->yystack.p_base, (size_t) (yystack.p_mark - yystack.p_base + 1) * sizeof(YYLTYPE));
#endif
        ctry           = ++save->ctry;
        yystate        = save->state;
        /* We tried shift, try reduce now */
        if ((yyn = yyctable[ctry]) >= 0) goto yyreduce;
        yyps->save     = save->save;
        save->save     = NULL;
        yyFreeState(save);

        /* Nothing left on the stack -- error */
        if (!yyps->save)
        {
#if YYDEBUG
            if (yydebug)
                fprintf(stderr, "%sdebug[%d,trial]: trial parse FAILED, entering ERROR mode\n",
                                YYPREFIX, yydepth);
#endif
            /* Restore state as it was in the most forward-advanced error */
            yylvp          = yylvals   + yyerrctx->lexeme;
#if defined(YYLTYPE) || defined(YYLTYPE_IS_DECLARED)
            yylpp          = yylpsns   + yyerrctx->lexeme;
#endif
            yylexp         = yylexemes + yyerrctx->lexeme;
            yychar         = yylexp[-1];
            yylval         = yylvp[-1];
#if defined(YYLTYPE) || defined(YYLTYPE_IS_DECLARED)
            yylloc         = yylpp[-1];
#endif
            yystack.s_mark = yystack.s_base + (yyerrctx->yystack.s_mark - yyerrctx->yystack.s_base);
            memcpy (yystack.s_base, yyerrctx->yystack.s_base, (size_t) (yystack.s_mark - yystack.s_base + 1) * sizeof(YYINT));
            yystack.l_mark = yystack.l_base + (yyerrctx->yystack.l_mark - yyerrctx->yystack.l_base);
            memcpy (yystack.l_base, yyerrctx->yystack.l_base, (size_t) (yystack.l_mark - yystack.l_base + 1) * sizeof(YYSTYPE));
#if defined(YYLTYPE) || defined(YYLTYPE_IS_DECLARED)
            yystack.p_mark = yystack.p_base + (yyerrctx->yystack.p_mark - yyerrctx->yystack.p_base);
            memcpy (yystack.p_base, yyerrctx->yystack.p_base, (size_t) (yystack.p_mark - yystack.p_base + 1) * sizeof(YYLTYPE));
#endif
            yystate        = yyerrctx->state;
            yyFreeState(yyerrctx);
            yyerrctx       = NULL;
        }
        yynewerrflag = 1;
    }
    if (yynewerrflag == 0) goto yyinrecovery;
#endif /* YYBTYACC */

    YYERROR_CALL("syntax error");
#if defined(YYLTYPE) || defined(YYLTYPE_IS_DECLARED)
    yyerror_loc_range[1] = yylloc; /* lookahead position is error start position */
#endif

#if !YYBTYACC
    goto yyerrlab; /* redundant goto avoids 'unused label' warning */
yyerrlab:
#endif
    ++yynerrs;

yyinrecovery:
    if (yyerrflag < 3)
    {
        yyerrflag = 3;
        for (;;)
        {
            if (((yyn = yysindex[*yystack.s_mark]) != 0) && (yyn += YYERRCODE) >= 0 &&
                    yyn <= YYTABLESIZE && yycheck[yyn] == (YYINT) YYERRCODE)
            {
#if YYDEBUG
                if (yydebug)
                    fprintf(stderr, "%s[%d]: state %d, error recovery shifting to state %d\n",
                                    YYDEBUGSTR, yydepth, *yystack.s_mark, yytable[yyn]);
#endif
                if (yystack.s_mark >= yystack.s_last && yygrowstack(&yystack) == YYENOMEM) goto yyoverflow;
                yystate = yytable[yyn];
                *++yystack.s_mark = yytable[yyn];
                *++yystack.l_mark = yylval;
#if defined(YYLTYPE) || defined(YYLTYPE_IS_DECLARED)
                /* lookahead position is error end position */
                yyerror_loc_range[2] = yylloc;
                YYLLOC_DEFAULT(yyloc, yyerror_loc_range, 2); /* position of error span */
                *++yystack.p_mark = yyloc;
#endif
                goto yyloop;
            }
            else
            {
#if YYDEBUG
                if (yydebug)
                    fprintf(stderr, "%s[%d]: error recovery discarding state %d\n",
                                    YYDEBUGSTR, yydepth, *yystack.s_mark);
#endif
                if (yystack.s_mark <= yystack.s_base) goto yyabort;
#if defined(YYLTYPE) || defined(YYLTYPE_IS_DECLARED)
                /* the current TOS position is the error start position */
                yyerror_loc_range[1] = *yystack.p_mark;
#endif
#if defined(YYDESTRUCT_CALL)
#if YYBTYACC
                if (!yytrial)
#endif /* YYBTYACC */
#if defined(YYLTYPE) || defined(YYLTYPE_IS_DECLARED)
                    YYDESTRUCT_CALL("error: discarding state",
                                    yystos[*yystack.s_mark], yystack.l_mark, yystack.p_mark);
#else
                    YYDESTRUCT_CALL("error: discarding state",
                                    yystos[*yystack.s_mark], yystack.l_mark);
#endif /* defined(YYLTYPE) || defined(YYLTYPE_IS_DECLARED) */
#endif /* defined(YYDESTRUCT_CALL) */
                --yystack.s_mark;
                --yystack.l_mark;
#if defined(YYLTYPE) || defined(YYLTYPE_IS_DECLARED)
                --yystack.p_mark;
#endif
            }
        }
    }
    else
    {
        if (yychar == YYEOF) goto yyabort;
#if YYDEBUG
        if (yydebug)
        {
            if ((yys = yyname[YYTRANSLATE(yychar)]) == NULL) yys = yyname[YYUNDFTOKEN];
            fprintf(stderr, "%s[%d]: state %d, error recovery discarding token %d (%s)\n",
                            YYDEBUGSTR, yydepth, yystate, yychar, yys);
        }
#endif
#if defined(YYDESTRUCT_CALL)
#if YYBTYACC
        if (!yytrial)
#endif /* YYBTYACC */
#if defined(YYLTYPE) || defined(YYLTYPE_IS_DECLARED)
            YYDESTRUCT_CALL("error: discarding token", yychar, &yylval, &yylloc);
#else
            YYDESTRUCT_CALL("error: discarding token", yychar, &yylval);
#endif /* defined(YYLTYPE) || defined(YYLTYPE_IS_DECLARED) */
#endif /* defined(YYDESTRUCT_CALL) */
        yychar = YYEMPTY;
        goto yyloop;
    }

yyreduce:
    yym = yylen[yyn];
#if YYDEBUG
    if (yydebug)
    {
        fprintf(stderr, "%s[%d]: state %d, reducing by rule %d (%s)",
                        YYDEBUGSTR, yydepth, yystate, yyn, yyrule[yyn]);
#ifdef YYSTYPE_TOSTRING
#if YYBTYACC
        if (!yytrial)
#endif /* YYBTYACC */
            if (yym > 0)
            {
                int i;
                fputc('<', stderr);
                for (i = yym; i > 0; i--)
                {
                    if (i != yym) fputs(", ", stderr);
                    fputs(YYSTYPE_TOSTRING(yystos[yystack.s_mark[1-i]],
                                           yystack.l_mark[1-i]), stderr);
                }
                fputc('>', stderr);
            }
#endif
        fputc('\n', stderr);
    }
#endif
    if (yym > 0)
        yyval = yystack.l_mark[1-yym];
    else
        memset(&yyval, 0, sizeof yyval);
#if defined(YYLTYPE) || defined(YYLTYPE_IS_DECLARED)

    /* Perform position reduction */
    memset(&yyloc, 0, sizeof(yyloc));
#if YYBTYACC
    if (!yytrial)
#endif /* YYBTYACC */
    {
        YYLLOC_DEFAULT(yyloc, &yystack.p_mark[-yym], yym);
        /* just in case YYERROR is invoked within the action, save
           the start of the rhs as the error start position */
        yyerror_loc_range[1] = yystack.p_mark[1-yym];
    }
#endif

    switch (yyn)
    {
case 1:
#line 155 "wrapit.y"
	{
		WVDefList *c_vdefs;
		WArgValList *c_argval;
		WSrcList *additional_src;
		WCallRec *c_callrec;
		char buffer[BUFFSIZE];
		char upper[BUFFSIZE];
		char lower[BUFFSIZE];
		int i;


		c_callrec = current->c_callrec;
		fprintf(stdout,fdef_fmt,current->c_defstring);
		c_vdefs = current->c_vdefs;
		while(c_vdefs != NULL) {
			sprintf(buffer,"%s ",CType(c_vdefs->def->datatype));
			if(c_vdefs->def->isptr) {
				strcat(buffer,"*");
			}
			strcat(buffer,c_vdefs->def->string);
			if(c_vdefs->def->array_spec != NULL) {
				strcat(buffer,c_vdefs->def->array_spec);
			}
			fprintf(stdout,"\t%s;\n",buffer);
			c_vdefs = c_vdefs->next;
		}
		
		c_argval = current->c_argval;
		while(c_argval != NULL) {
			fprintf(stdout,argval_fmt,
				c_argval->arec->assign_to,
				CType(c_argval->arec->datatype),
				c_argval->arec->pnum,
				c_argval->arec->totalp,
				c_argval->arec->ndims==NULL?"NULL":c_argval->arec->ndims,
				c_argval->arec->dimsizes==NULL?"NULL":c_argval->arec->dimsizes,
				c_argval->arec->missing==NULL?"NULL":c_argval->arec->missing,
				c_argval->arec->hasmissing==NULL?"NULL":c_argval->arec->hasmissing,
				c_argval->arec->type==NULL?"NULL":c_argval->arec->type,
				c_argval->arec->rw);
			additional_src = c_argval->arec->additional_src;
			while(additional_src != NULL) {
				if(additional_src->src) {
					fprintf(stdout,"%s",additional_src->src);
				}
				additional_src = additional_src->next;
			}
			c_argval = c_argval->next;	
		}
		c_vdefs = current->c_vdefs;
		while(c_vdefs != NULL) {
			additional_src = c_vdefs->def->additional_src;
			while(additional_src != NULL) {
				if(additional_src->order == 0) {
					if(additional_src->src) {
						fprintf(stdout,"%s",additional_src->src);
					}
				}
				additional_src = additional_src->next;
			}
			c_vdefs = c_vdefs->next;
		}
		c_vdefs = current->c_vdefs;
		while(c_vdefs != NULL) {
			additional_src = c_vdefs->def->additional_src;
			while(additional_src != NULL) {
				if(additional_src->order == 1) {
					if(additional_src->src) {
						fprintf(stdout,"%s",additional_src->src);
					}
				}
				additional_src = additional_src->next;
			}
			c_vdefs = c_vdefs->next;
		}
		c_callrec = current->c_callrec;
		fprintf(stdout,"\t%s",c_callrec->callstring);
		sprintf(buffer,"(");
		for(i = 0; i < c_callrec->n_args;i++) {
			if(c_callrec->arg_strings[i] == NULL) {
				strcat(buffer,"NULL");
			} else if(!c_callrec->arg_strings[i]->isptr) {
				strcat(buffer,"&");
				strcat(buffer,c_callrec->arg_strings[i]->string);
			} else {
				strcat(buffer,c_callrec->arg_strings[i]->string);
			}
			if(i!= c_callrec->n_args-1) {
				strcat(buffer,",");
			} 
		}
		if(c_callrec->nstrs != 0) {
			strcat(buffer,",");
			for(;i < c_callrec->n_args+c_callrec->nstrs;i++) {
				strcat(buffer,c_callrec->arg_strings[i]->string);
				if(i!= c_callrec->n_args + c_callrec->nstrs -1) {
					strcat(buffer,",");
				} 
			}
		}
		strcat(buffer,");\n\n");
		fprintf(stdout,"%s",buffer);
		c_vdefs = current->c_vdefs;
		while(c_vdefs != NULL) {
			additional_src = c_vdefs->def->additional_src;
			while(additional_src != NULL) {
				if(additional_src->order == 2) {
					if(additional_src->src) {
						fprintf(stdout,"%s",additional_src->src);
					}
				}
				additional_src = additional_src->next;
			}
			c_vdefs = c_vdefs->next;
		}
		fprintf(stdout,"\t%s\n",current->rtrn);
		fprintf(stdout,"}\n");
		
		nargs = 0;
		w_nargs = 0;
	}
#line 1635 "y.tab.c"
break;
case 2:
#line 277 "wrapit.y"
	{
		WVDefList *c_vdefs;
		WArgValList *c_argval;
		WSrcList *additional_src;
		WCallRec *c_callrec;
		char buffer[BUFFSIZE];
		char upper[BUFFSIZE];
		char lower[BUFFSIZE];
		int i;


		c_callrec = current->c_callrec;
		fprintf(stdout,fdef_fmt,current->c_defstring);
		c_vdefs = current->c_vdefs;
		while(c_vdefs != NULL) {
			sprintf(buffer,"%s ",CType(c_vdefs->def->datatype));
			if(c_vdefs->def->isptr) {
				strcat(buffer,"*");
			}
			strcat(buffer,c_vdefs->def->string);
			if(c_vdefs->def->array_spec != NULL) {
				strcat(buffer,c_vdefs->def->array_spec);
			}
			fprintf(stdout,"\t%s;\n",buffer);
			c_vdefs = c_vdefs->next;
		}
		
		c_argval = current->c_argval;
		while(c_argval != NULL) {
			fprintf(stdout,argval_fmt,
				c_argval->arec->assign_to,
				CType(c_argval->arec->datatype),
				c_argval->arec->pnum,
				c_argval->arec->totalp,
				c_argval->arec->ndims==NULL?"NULL":c_argval->arec->ndims,
				c_argval->arec->dimsizes==NULL?"NULL":c_argval->arec->dimsizes,
				c_argval->arec->missing==NULL?"NULL":c_argval->arec->missing,
				c_argval->arec->hasmissing==NULL?"NULL":c_argval->arec->hasmissing,
				c_argval->arec->type==NULL?"NULL":c_argval->arec->type,
				c_argval->arec->rw);
			if(c_argval->arec->additional_src != NULL) {
				fprintf(stdout,"%s",c_argval->arec->additional_src);
			}
			c_argval = c_argval->next;
		}
		c_vdefs = current->c_vdefs;
		while(c_vdefs != NULL) {
			additional_src = c_vdefs->def->additional_src;
			while(additional_src != NULL) {
				if(additional_src->order==0 ) {
					if(additional_src->src) {
						fprintf(stdout,"%s",additional_src->src);
					}
				} 
				additional_src = additional_src->next;
			}
			c_vdefs = c_vdefs->next;
		}
		c_vdefs = current->c_vdefs;
		while(c_vdefs != NULL) {
			additional_src = c_vdefs->def->additional_src;
			while(additional_src != NULL) {
				if(additional_src->order==1 ) {
					if(additional_src->src) {
						fprintf(stdout,"%s",additional_src->src);
					}
				} 
				additional_src = additional_src->next;
			}
			c_vdefs = c_vdefs->next;
		}
		c_callrec = current->c_callrec;
		fprintf(stdout,"\t%s",c_callrec->callstring);
		sprintf(buffer,"(");
		for(i = 0; i < c_callrec->n_args;i++) {
			if(c_callrec->arg_strings[i] == NULL) {
				strcat(buffer,"NULL");
			} else if(!c_callrec->arg_strings[i]->isptr) {
				strcat(buffer,"&");
				strcat(buffer,c_callrec->arg_strings[i]->string);
			} else {
				strcat(buffer,c_callrec->arg_strings[i]->string);
			}
		
			if((i!= c_callrec->n_args-1)) {
				strcat(buffer,",");
			} 
		}
		if(c_callrec->nstrs != 0) {
			strcat(buffer,",");
			for(;i < c_callrec->n_args+c_callrec->nstrs;i++) {
				strcat(buffer,c_callrec->arg_strings[i]->string);
				if(i!= c_callrec->n_args + c_callrec->nstrs -1) {
					strcat(buffer,",");
				} 
			}
		}
		strcat(buffer,");\n\n");
		fprintf(stdout,"%s",buffer);
		c_vdefs = current->c_vdefs;
		while(c_vdefs != NULL) {
			additional_src = c_vdefs->def->additional_src;
			while(additional_src != NULL) {
				if(additional_src->order == 2) {
					if(additional_src->src) {
						fprintf(stdout,"%s",additional_src->src);
					}
				}
				additional_src = additional_src->next;
			}
			c_vdefs = c_vdefs->next;
		}
		fprintf(stdout,"\t%s\n",current->rtrn);
		fprintf(stdout,"}\n");
		
		nargs = 0;
		w_nargs = 0;
	}
#line 1757 "y.tab.c"
break;
case 3:
#line 396 "wrapit.y"
	{
/*
* No wrapper info, so output records have not been built.
*/
		int i,j,tmpj,nstrs;
		NclSymbol *s,*s0;
		NclSymbol *wp;
		char buffer[BUFFSIZE];
		char upper[BUFFSIZE];
		char lower[BUFFSIZE];
		WGetArgValue *arg;
		WCallRec *thecall;
		NclSymbol **tmp;
		WCentry *tmpc;
		WSrcList *tmp_src;

		thecall = WNewCallRec(yystack.l_mark[-1].sym->name,nargs);
/*
* Now since its a one-one function the wrapper parameter information must
* be take from the FORTRAN information This list would otherwise be created
* already.
*/
		for(i = 0; i < strlen(yystack.l_mark[-1].sym->name); i++) {
                        if((!isdigit(yystack.l_mark[-1].sym->name[i]))&&(isalpha(yystack.l_mark[-1].sym->name[i]))) {
                        	if(isupper(yystack.l_mark[-1].sym->name[i])) {
                               		upper[i] = yystack.l_mark[-1].sym->name[i];
                               		lower[i] = (char)((int)yystack.l_mark[-1].sym->name[i] + 32);
                        	} else {
                                	lower[i] = yystack.l_mark[-1].sym->name[i];
                                	upper[i] = (char)((int)yystack.l_mark[-1].sym->name[i] - 32);
                        	}
			} else {
				upper[i] = lower[i] = yystack.l_mark[-1].sym->name[i];
			}
                }
		lower[i] = '\0';
		upper[i] = '\0';
		fprintf(stdout,"extern %s NGCALLF(%s,%s)();\n",CType(yystack.l_mark[-1].sym->u.func->datatype),lower,upper);

		current->f_or_p = 1;
		current->c_defstring = malloc(strlen(yystack.l_mark[-1].sym->name)+1);
		strcpy(current->c_defstring, yystack.l_mark[-1].sym->name);

		sprintf(buffer,"%s_ret",yystack.l_mark[-1].sym->name);
		tmpc = WNewVDef(buffer,yystack.l_mark[-1].sym->u.func->datatype,0,NULL,0);

		sprintf(buffer,"%s = NGCALLF(%s,%s)",tmpc->string,lower,upper);
		thecall->callstring = malloc(strlen(buffer)+1);
		strcpy(thecall->callstring,buffer);

		sprintf(buffer,"%s_ret_dimsizes",yystack.l_mark[-1].sym->name);
		(void)WNewVDef(buffer,NCL_long,0,"[NCL_MAX_DIMENSIONS]",0);
		

		for (i = 0; i < yystack.l_mark[-1].sym->u.func->n_args; i++) {
			s = yystack.l_mark[-1].sym->u.func->args[i];
/*
* Also since no wrapper only need to retrieve pointer to var
* no need for ndims,dimsizes,missing....
*/
			wp = _NclAddInScope(current->wrec,(char*)s->name,WPARAM);
			wp->u.wparam = (WParamInfo*)malloc(sizeof(WParamInfo));


			arg = WNewArgVal();
			if(s->u.farg->datatype == NCL_none) {
				s->u.farg->datatype = wp->u.wparam->datatype = FType(s->name);
			} else {
				wp->u.wparam->datatype = s->u.farg->datatype;
			}
			wp->u.wparam->n_dims = s->u.farg->n_dims;
			for(j = 0; j < s->u.farg->n_dims; j++) {
				wp->u.wparam->dim_sizes[j] = s->u.farg->dim_sizes[j];
			}
			arg->assign_to = s->name;
			arg->datatype = s->u.farg->datatype;
			arg->pnum = i;
			arg->totalp = yystack.l_mark[-1].sym->u.func->n_args;
			arg->rw = 1;
			arg->nd[0] = '\t';
			arg->nd[1] = ')';
			arg->nd[2] = ';';
			arg->nd[3] = '\n';
			arg->nd[4] = '\0';
			wp->u.wparam->getarg = arg;
			thecall->arg_strings[i] = WNewVDef(s->name,s->u.farg->datatype,1,NULL,0);
		}
/*
* This loop searches for string arguments and defines the length argument needed by FORTRAN
*/
		nstrs = 0;
		for (i = 0; i < yystack.l_mark[-1].sym->u.func->n_args; i++) {
			s = yystack.l_mark[-1].sym->u.func->args[i];
			if(s->u.farg->datatype == NCL_string) {
				sprintf(buffer,"%s_len",s->name);
				thecall->arg_strings[yystack.l_mark[-1].sym->u.func->n_args+nstrs] = WNewVDef(buffer,NCL_int,0,NULL,0);
				sprintf(buffer,"\t%s_len = strlen(NrmQuarkToString(*%s));\n",s->name,s->name);
				tmp_src = thecall->arg_strings[yystack.l_mark[-1].sym->u.func->n_args+nstrs]->additional_src;
				thecall->arg_strings[yystack.l_mark[-1].sym->u.func->n_args+nstrs]->additional_src = WNewAdditionalSrc(buffer,1);
				thecall->arg_strings[yystack.l_mark[-1].sym->u.func->n_args+nstrs]->additional_src->next = tmp_src;


				sprintf(buffer,"%s_str",s->name);
				thecall->arg_strings[i] = WNewVDef(buffer,NCL_char,1,NULL,1);
				sprintf(buffer,"\t%s_str = malloc(%s_len + 1);\n\tstrcpy(%s_str,NrmQuarkToString(*%s));\n",s->name,s->name,s->name,s->name);
				tmp_src = thecall->arg_strings[i]->additional_src;
				
				thecall->arg_strings[i]->additional_src = WNewAdditionalSrc(buffer,1);
				thecall->arg_strings[i]->additional_src->next = tmp_src;
				sprintf(buffer,"\t%s_str[%s_len] = \'\\0\';\n\t*%s = NrmStringToQuark(%s_str);\n\tfree(%s_str);\n",s->name,s->name,s->name,s->name,s->name);
				tmp_src = thecall->arg_strings[i]->additional_src;
				thecall->arg_strings[i]->additional_src = WNewAdditionalSrc(buffer,2);
				thecall->arg_strings[i]->additional_src->next = tmp_src;

				nstrs++;
			} else {
				for(j = 0; j < yystack.l_mark[-1].sym->u.func->args[i]->u.farg->n_dims; j++) {
					if(yystack.l_mark[-1].sym->u.func->args[i]->u.farg->dim_refs[j] != NULL) {
						s0 = _NclLookUpInScope(current->wrec,yystack.l_mark[-1].sym->u.func->args[i]->name);
						DoDimsizes(s0);
						sprintf(buffer,"\tif(*%s != (int)%s_dimsizes[%d]) {\n\t\tNhlPError(NhlFATAL,NhlEUNKNOWN,\"%s: dimension size of dimension (%d) of %s must be equal to the value of %s\");\n\t\treturn(NhlFATAL);\n\t}\n",yystack.l_mark[-1].sym->u.func->args[i]->u.farg->dim_refs[j]->name,yystack.l_mark[-1].sym->u.func->args[i]->name,j,yystack.l_mark[-1].sym->name,j,yystack.l_mark[-1].sym->u.func->args[i]->name,yystack.l_mark[-1].sym->u.func->args[i]->u.farg->dim_refs[j]->name);
						tmp_src = thecall->arg_strings[i]->additional_src;
						thecall->arg_strings[i]->additional_src = WNewAdditionalSrc(buffer,1);
						thecall->arg_strings[i]->additional_src->next = tmp_src;
					}
				}
			}
		}
		thecall->nstrs = nstrs;
		sprintf(buffer,"%s_ret_dimsizes[0] = 1;\n\treturn(NclReturnValue(&%s_ret,1,%s_ret_dimsizes,NULL,%s,1));",yystack.l_mark[-1].sym->name,yystack.l_mark[-1].sym->name,yystack.l_mark[-1].sym->name,NType(yystack.l_mark[-1].sym->u.func->datatype));
		current->rtrn = malloc(strlen(buffer)+1);
		strcpy(current->rtrn,buffer);
		
	}
#line 1895 "y.tab.c"
break;
case 4:
#line 531 "wrapit.y"
	{
/*
* No wrapper info, so output records have not been built.
*/
		int i,j,nstrs,tmpj;
		NclSymbol *s,*s0;
		NclSymbol *wp;
		char buffer[BUFFSIZE];
		char lower[BUFFSIZE];
		char upper[BUFFSIZE];
		WGetArgValue *arg;
		WCallRec *thecall;
		NclSymbol **tmp;
		WSrcList *tmp_src;

		thecall = WNewCallRec(yystack.l_mark[-1].sym->name,nargs);
/*
* Now since its a one-one function the wrapper parameter information must
* be take from the FORTRAN information This list would otherwise be created
* already.
*/
		for(i = 0; i < strlen(yystack.l_mark[-1].sym->name); i++) {
			if((!isdigit(yystack.l_mark[-1].sym->name[i]))&&(isalpha(yystack.l_mark[-1].sym->name[i]))) {
                        	if(isupper(yystack.l_mark[-1].sym->name[i])) {
                                	upper[i] = yystack.l_mark[-1].sym->name[i];
                                	lower[i] = (char)((int)yystack.l_mark[-1].sym->name[i] + 32);
                        	} else {
                                	lower[i] = yystack.l_mark[-1].sym->name[i];
                                	upper[i] = (char)((int)yystack.l_mark[-1].sym->name[i] - 32);
                        	}
			} else {
                                	upper[i] = lower[i] = yystack.l_mark[-1].sym->name[i];
			}
                }
		lower[i] = '\0';
		upper[i] = '\0';
		fprintf(stdout,"extern void NGCALLF(%s,%s)();\n",lower,upper);
		sprintf(buffer,"NGCALLF(%s,%s)",lower,upper);
		thecall->callstring = malloc(strlen(buffer)+1);
		strcpy(thecall->callstring,buffer);
		current->f_or_p = 0;
		current->c_defstring = malloc(strlen(yystack.l_mark[-1].sym->name)+1);
		strcpy(current->c_defstring, yystack.l_mark[-1].sym->name);
		for (i = 0; i < yystack.l_mark[-1].sym->u.subr->n_args; i++) {
			s = yystack.l_mark[-1].sym->u.subr->args[i];
/*
* Also since no wrapper only need to retrieve pointer to var
* no need for ndims,dimsizes,missing....
*/
			wp = _NclAddInScope(current->wrec,(char*)s->name,WPARAM);
			wp->u.wparam = (WParamInfo*)malloc(sizeof(WParamInfo));


			arg = WNewArgVal();
			if(s->u.farg->datatype == NCL_none) {
				s->u.farg->datatype = wp->u.wparam->datatype = FType(s->name);
			} else {
				wp->u.wparam->datatype = s->u.farg->datatype;
			}
			wp->u.wparam->n_dims = s->u.farg->n_dims;
			for(j = 0; j < s->u.farg->n_dims; j++) {
				wp->u.wparam->dim_sizes[j] = s->u.farg->dim_sizes[j];
			}
			arg->assign_to = s->name;
			arg->datatype = s->u.farg->datatype;
			arg->pnum = i;
			arg->totalp = yystack.l_mark[-1].sym->u.subr->n_args;
			arg->rw = 1;
			arg->nd[0] = '\t';
			arg->nd[1] = ')';
			arg->nd[2] = ';';
			arg->nd[3] = '\n';
			arg->nd[4] = '\0';
			wp->u.wparam->getarg = arg;
			thecall->arg_strings[i] = WNewVDef(s->name,s->u.farg->datatype,1,NULL,0);
		}
/*
* This loop searches for string arguments and defines the length argument needed by FORTRAN
*/
		nstrs = 0;
		for (i = 0; i < yystack.l_mark[-1].sym->u.subr->n_args; i++) {
			s = yystack.l_mark[-1].sym->u.subr->args[i];
			if(s->u.farg->datatype == NCL_string) {
				sprintf(buffer,"%s_len",s->name);
				thecall->arg_strings[yystack.l_mark[-1].sym->u.subr->n_args+nstrs] = WNewVDef(buffer,NCL_int,0,NULL,0);
				sprintf(buffer,"\t%s_len = strlen(NrmQuarkToString(*%s));\n",s->name,s->name);
				tmp_src = thecall->arg_strings[yystack.l_mark[-1].sym->u.subr->n_args+nstrs]->additional_src;
				thecall->arg_strings[yystack.l_mark[-1].sym->u.subr->n_args+nstrs]->additional_src = WNewAdditionalSrc(buffer,1);
				thecall->arg_strings[yystack.l_mark[-1].sym->u.subr->n_args+nstrs]->additional_src->next = tmp_src;


				sprintf(buffer,"%s_str",s->name);
				thecall->arg_strings[i] = WNewVDef(buffer,NCL_char,1,NULL,1);
				sprintf(buffer,"\t%s_str = malloc(%s_len + 1);\n\tstrcpy(%s_str,NrmQuarkToString(*%s));\n",s->name,s->name,s->name,s->name);
				tmp_src = thecall->arg_strings[i]->additional_src;
				
				thecall->arg_strings[i]->additional_src = WNewAdditionalSrc(buffer,1);
				thecall->arg_strings[i]->additional_src->next = tmp_src;
				sprintf(buffer,"\t%s_str[%s_len] = \'\\0\';\n\t*%s = NrmStringToQuark(%s_str);\n\tfree(%s_str);\n",s->name,s->name,s->name,s->name,s->name);
				tmp_src = thecall->arg_strings[i]->additional_src;
				thecall->arg_strings[i]->additional_src = WNewAdditionalSrc(buffer,2);
				thecall->arg_strings[i]->additional_src->next = tmp_src;
				nstrs++;
			} else {
				for(j = 0; j < yystack.l_mark[-1].sym->u.subr->args[i]->u.farg->n_dims; j++) {
					if(yystack.l_mark[-1].sym->u.subr->args[i]->u.farg->dim_refs[j] != NULL) {
						s0 = _NclLookUpInScope(current->wrec,yystack.l_mark[-1].sym->u.subr->args[i]->name);
						DoDimsizes(s0);
						sprintf(buffer,"\tif(*%s != (int)%s_dimsizes[%d]) {\n\t\tNhlPError(NhlFATAL,NhlEUNKNOWN,\"%s: dimension size of dimension (%d) of %s must be equal to the value of %s\");\n\t\treturn(NhlFATAL);\n\t}\n",yystack.l_mark[-1].sym->u.subr->args[i]->u.farg->dim_refs[j]->name,yystack.l_mark[-1].sym->u.subr->args[i]->name,j,yystack.l_mark[-1].sym->name,j,yystack.l_mark[-1].sym->u.subr->args[i]->name,yystack.l_mark[-1].sym->u.subr->args[i]->u.farg->dim_refs[j]->name);
						tmp_src = thecall->arg_strings[i]->additional_src;
						thecall->arg_strings[i]->additional_src = WNewAdditionalSrc(buffer,1);
						thecall->arg_strings[i]->additional_src->next = tmp_src;
					}
				}
			}
		}
		thecall->nstrs = nstrs;
		current->rtrn = malloc(strlen("return(NhlNOERROR);")+1);
		strcpy(current->rtrn,"return(NhlNOERROR);");
		
		
	}
#line 2021 "y.tab.c"
break;
case 5:
#line 654 "wrapit.y"
	{
        }
#line 2027 "y.tab.c"
break;
case 6:
#line 656 "wrapit.y"
	{ (void)WNewCallRec(yystack.l_mark[-1].sym->name,nargs); }
#line 2032 "y.tab.c"
break;
case 7:
#line 657 "wrapit.y"
	{
        }
#line 2038 "y.tab.c"
break;
case 8:
#line 662 "wrapit.y"
	{
		WrapSrcListNode* tmp,*tmp2;
		int count = 0;
		yystack.l_mark[-5].sym->type = FUNC;
		yystack.l_mark[-5].sym->u.func = (WFuncInfo*)malloc(sizeof(WFuncInfo));

                tmp = yystack.l_mark[-2].list;
                while(tmp != NULL) {
                        count++;
                        tmp = tmp->next;
                }
		yystack.l_mark[-5].sym->u.func->n_args = count;
		yystack.l_mark[-5].sym->u.func->args = (NclSymbol**)malloc(sizeof(NclSymbol*)*count);
		if(yystack.l_mark[-7].ftyp == NULL) {
			yystack.l_mark[-5].sym->u.func->datatype = FType(yystack.l_mark[-5].sym->name);
		} else {
			yystack.l_mark[-5].sym->u.func->datatype = yystack.l_mark[-7].ftyp->datatype;
		}
		tmp = yystack.l_mark[-2].list;
		for(count = 0; count < yystack.l_mark[-5].sym->u.func->n_args; count++) {
			yystack.l_mark[-5].sym->u.func->args[count] = tmp->node;
			tmp2 = tmp;
			tmp = tmp->next;
			free(tmp2);
		}
		yyval.sym = yystack.l_mark[-5].sym;
		

	}
#line 2071 "y.tab.c"
break;
case 9:
#line 692 "wrapit.y"
	{
		yystack.l_mark[-4].sym->type = FUNC;
		yystack.l_mark[-4].sym->u.func = (WFuncInfo*)malloc(sizeof(WFuncInfo));
		yystack.l_mark[-4].sym->u.func->n_args = 0;
		yystack.l_mark[-4].sym->u.func->args = NULL;
		if(yystack.l_mark[-6].ftyp == NULL) {
			yystack.l_mark[-4].sym->u.func->datatype = FType(yystack.l_mark[-4].sym->name);
		} else {
			yystack.l_mark[-4].sym->u.func->datatype = yystack.l_mark[-6].ftyp->datatype;
		}
		yyval.sym = yystack.l_mark[-4].sym;
	}
#line 2087 "y.tab.c"
break;
case 10:
#line 707 "wrapit.y"
	{
		WrapSrcListNode* tmp,*tmp2;
		int count = 0;
		yystack.l_mark[-4].sym->type = SUBR;
		yystack.l_mark[-4].sym->u.subr = (WSubrInfo*)malloc(sizeof(WSubrInfo));
	
		tmp = yystack.l_mark[-2].list;
		while(tmp != NULL) {
			count++;
			tmp = tmp->next;
		}
		yystack.l_mark[-4].sym->u.subr->args = (NclSymbol**)malloc(sizeof(NclSymbol*)*count);
		yystack.l_mark[-4].sym->u.subr->n_args = count;
		tmp = yystack.l_mark[-2].list;
		for( count = 0; count < yystack.l_mark[-4].sym->u.subr->n_args; count++ ) {
			yystack.l_mark[-4].sym->u.subr->args[count] = tmp->node;
			tmp2 =tmp;
			tmp = tmp->next;
			free(tmp2);
		}
		yyval.sym = yystack.l_mark[-4].sym;
	}
#line 2113 "y.tab.c"
break;
case 11:
#line 730 "wrapit.y"
	{
		yystack.l_mark[-3].sym->type = SUBR;
		yystack.l_mark[-3].sym->u.subr = (WSubrInfo*)malloc(sizeof(WSubrInfo));
		yystack.l_mark[-3].sym->u.subr->args = NULL;
		yystack.l_mark[-3].sym->u.subr->n_args = 0;
		yyval.sym = yystack.l_mark[-3].sym;
	}
#line 2124 "y.tab.c"
break;
case 12:
#line 739 "wrapit.y"
	{
	}
#line 2130 "y.tab.c"
break;
case 13:
#line 742 "wrapit.y"
	{
	}
#line 2136 "y.tab.c"
break;
case 14:
#line 746 "wrapit.y"
	{
	}
#line 2142 "y.tab.c"
break;
case 15:
#line 749 "wrapit.y"
	{
	}
#line 2148 "y.tab.c"
break;
case 16:
#line 753 "wrapit.y"
	{
		NclSymbol *s;
		char buffer[10];
		yystack.l_mark[0].sym->type = FARG;
		yystack.l_mark[0].sym->u.farg = (WFargInfo*)malloc(sizeof(WFargInfo));
		yystack.l_mark[0].sym->u.farg->arg_num = nargs;
		yystack.l_mark[0].sym->u.farg->dim_sizes[0] = 1;
		yystack.l_mark[0].sym->u.farg->dim_refs[0] = NULL;
		yystack.l_mark[0].sym->u.farg->n_dims = 1;
		sprintf(buffer,"FARG%d",nargs++);
#if  YYDEBUG
#endif
		s = _NclAddInScope(current->wrec,buffer,XFARG);
		s->u.xref = yystack.l_mark[0].sym;
		yyval.list = WMakeListNode();
		yyval.list->node = yystack.l_mark[0].sym;
		yyval.list->next = NULL;
	}
#line 2170 "y.tab.c"
break;
case 17:
#line 772 "wrapit.y"
	{
		NclSymbol *s;
		char buffer[BUFFSIZE];
		yystack.l_mark[-2].sym->u.farg = (WFargInfo*)malloc(sizeof(WFargInfo));
		yystack.l_mark[-2].sym->type = FARG;
		yystack.l_mark[-2].sym->u.farg->arg_num = nargs;
		yystack.l_mark[-2].sym->u.farg->dim_sizes[0] = 1;
		yystack.l_mark[-2].sym->u.farg->dim_refs[0] = NULL;
		yystack.l_mark[-2].sym->u.farg->n_dims = 1;
		sprintf(buffer,"FARG%d",nargs++);
#if  YYDEBUG
#endif

		s = _NclAddInScope(current->wrec,buffer,XFARG);
		s->u.xref = yystack.l_mark[-2].sym;
		yyval.list = WMakeListNode();
		yyval.list->node = yystack.l_mark[-2].sym;
		yyval.list->next = yystack.l_mark[0].list;
	}
#line 2193 "y.tab.c"
break;
case 18:
#line 793 "wrapit.y"
	{
	}
#line 2199 "y.tab.c"
break;
case 19:
#line 796 "wrapit.y"
	{
	}
#line 2205 "y.tab.c"
break;
case 20:
#line 801 "wrapit.y"
	{
		WrapSrcListNode * tmp,*tmp2;
/*
*------> This is where problems with MD char arrays happens
*/
		tmp = yystack.l_mark[-1].list;
		while(tmp != NULL) {
			tmp2 = tmp;
			((NclSymbol*)tmp->node)->u.farg->datatype = yystack.l_mark[-2].ftyp->datatype;
			if((yystack.l_mark[-2].ftyp->datatype == NCL_char)&&(yystack.l_mark[-2].ftyp->size != -1)) {
				((NclSymbol*)tmp->node)->u.farg->dim_sizes[0] = yystack.l_mark[-2].ftyp->size;
				((NclSymbol*)tmp->node)->u.farg->dim_refs[0] = NULL;
			}
			tmp = tmp->next;
			free(tmp2);
		}

	}
#line 2227 "y.tab.c"
break;
case 21:
#line 819 "wrapit.y"
	{
		WrapSrcListNode * tmp,*tmp2;

		tmp = yystack.l_mark[-1].list;
		while(tmp != NULL) {
			tmp2 = tmp;
			((NclSymbol*)tmp->node)->u.farg->datatype = yystack.l_mark[-2].ftyp->datatype;
			if((yystack.l_mark[-2].ftyp->datatype == NCL_char)&&(yystack.l_mark[-2].ftyp->size != -1)) {
				((NclSymbol*)tmp->node)->u.farg->dim_sizes[0] = yystack.l_mark[-2].ftyp->size;
				((NclSymbol*)tmp->node)->u.farg->dim_refs[0] = NULL;
			}
			tmp = tmp->next;
			free(tmp2);
		}
	}
#line 2246 "y.tab.c"
break;
case 22:
#line 836 "wrapit.y"
	{	yyval.ftyp = (FTypeVal*)malloc(sizeof(FTypeVal));
		yyval.ftyp->datatype = NCL_byte;
		yyval.ftyp->size = -1;
	}
#line 2254 "y.tab.c"
break;
case 23:
#line 841 "wrapit.y"
	{
		yyval.ftyp = (FTypeVal*)malloc(sizeof(FTypeVal));
		yyval.ftyp->datatype = NCL_int;
		yyval.ftyp->size = -1;
	}
#line 2263 "y.tab.c"
break;
case 24:
#line 847 "wrapit.y"
	{
		yyval.ftyp = (FTypeVal*)malloc(sizeof(FTypeVal));
		yyval.ftyp->datatype = NCL_logical;
		yyval.ftyp->size = -1;
	}
#line 2272 "y.tab.c"
break;
case 25:
#line 853 "wrapit.y"
	{
		yyval.ftyp = (FTypeVal*)malloc(sizeof(FTypeVal));
		yyval.ftyp->datatype = NCL_double;
		yyval.ftyp->size = -1;
	}
#line 2281 "y.tab.c"
break;
case 26:
#line 859 "wrapit.y"
	{
		yyval.ftyp = (FTypeVal*)malloc(sizeof(FTypeVal));
		yyval.ftyp->datatype = NCL_float;
		yyval.ftyp->size = -1;
	}
#line 2290 "y.tab.c"
break;
case 27:
#line 865 "wrapit.y"
	{
		yyval.ftyp = (FTypeVal*)malloc(sizeof(FTypeVal));
		yyval.ftyp->datatype = NCL_none;
		yyval.ftyp->size = -1;
	}
#line 2299 "y.tab.c"
break;
case 28:
#line 871 "wrapit.y"
	{
		yyval.ftyp = (FTypeVal*)malloc(sizeof(FTypeVal));
		yyval.ftyp->datatype = NCL_none;
		yyval.ftyp->size = -1;
	}
#line 2308 "y.tab.c"
break;
case 29:
#line 877 "wrapit.y"
	{
		yyval.ftyp = (FTypeVal*)malloc(sizeof(FTypeVal));
		yyval.ftyp->datatype = NCL_none;
		yyval.ftyp->size = -1;
	}
#line 2317 "y.tab.c"
break;
case 30:
#line 883 "wrapit.y"
	{
		yyval.ftyp = (FTypeVal*)malloc(sizeof(FTypeVal));
		yyval.ftyp->datatype = NCL_none;
		yyval.ftyp->size = -1;
	}
#line 2326 "y.tab.c"
break;
case 31:
#line 888 "wrapit.y"
	{
		yyval.ftyp = (FTypeVal*)malloc(sizeof(FTypeVal));
		yyval.ftyp->datatype =  NCL_char;
		yyval.ftyp->size = yystack.l_mark[0].integer;
	}
#line 2335 "y.tab.c"
break;
case 32:
#line 894 "wrapit.y"
	{
		yyval.ftyp = (FTypeVal*)malloc(sizeof(FTypeVal));
		yyval.ftyp->datatype =  NCL_char;
		yyval.ftyp->size = -1;
	}
#line 2344 "y.tab.c"
break;
case 33:
#line 900 "wrapit.y"
	{
		yyval.ftyp = (FTypeVal*)malloc(sizeof(FTypeVal));
		yyval.ftyp->datatype = NCL_string;
		yyval.ftyp->size = -1;
	}
#line 2353 "y.tab.c"
break;
case 34:
#line 906 "wrapit.y"
	{
		yyval.ftyp = (FTypeVal*)malloc(sizeof(FTypeVal));
		yyval.ftyp->size = -1;
		switch(yystack.l_mark[0].integer) {
		case 1:
			yyval.ftyp->datatype = NCL_byte;
			break;
		case 2:
			yyval.ftyp->datatype = NCL_short;
			break;
		case 4:
			yyval.ftyp->datatype = NCL_int;
			break;
		default:
			yyval.ftyp->datatype = NCL_none;
		}
	}
#line 2374 "y.tab.c"
break;
case 35:
#line 924 "wrapit.y"
	{
		yyval.ftyp = (FTypeVal*)malloc(sizeof(FTypeVal));
		yyval.ftyp->size = -1;
		switch(yystack.l_mark[0].integer){
		case 1:
			yyval.ftyp->datatype = NCL_byte;
			break;
		case 2:
			yyval.ftyp->datatype = NCL_short;
			break;
		case 4:
			yyval.ftyp->datatype = NCL_int;
			break;
		case 8:
			if(sizeof(long)==8) {
				yyval.ftyp->datatype = NCL_long;
			} else {
				yyval.ftyp->datatype = NCL_none;
			}
		default:
			yyval.ftyp = NCL_none;
		}
	}
#line 2401 "y.tab.c"
break;
case 36:
#line 948 "wrapit.y"
	{
		yyval.ftyp = (FTypeVal*)malloc(sizeof(FTypeVal));
		yyval.ftyp->size = -1;
		switch(yystack.l_mark[0].integer){
		case 1:
			yyval.ftyp->datatype = NCL_byte;
			break;
		case 2:
			yyval.ftyp->datatype = NCL_short;
			break;
		case 4:
			yyval.ftyp->datatype = NCL_logical;
			break;
		default:
			yyval.ftyp->datatype = NCL_none;
		}
	}
#line 2422 "y.tab.c"
break;
case 37:
#line 966 "wrapit.y"
	{
		yyval.ftyp = (FTypeVal*)malloc(sizeof(FTypeVal));
		yyval.ftyp->size = -1;
		switch(yystack.l_mark[0].integer){
		case 1:
		case 2:
			yyval.ftyp->datatype = NCL_none;
			break;
		case 4:
			yyval.ftyp->datatype = NCL_float;
			break;
		case 8:
			yyval.ftyp->datatype = NCL_double;
			break;
		default:
			yyval.ftyp = NCL_none;
		}
	}
#line 2444 "y.tab.c"
break;
case 38:
#line 988 "wrapit.y"
	{
		if(yystack.l_mark[0].sym != NULL) {
			yyval.list = (WrapSrcListNode*) malloc(sizeof(WrapSrcListNode));
			yyval.list->node = yystack.l_mark[0].sym;
			yyval.list->next = NULL;
		} else {
			yyval.list = NULL;
		}
	}
#line 2457 "y.tab.c"
break;
case 39:
#line 998 "wrapit.y"
	{
		if(yystack.l_mark[0].sym != NULL) {
			yyval.list = (WrapSrcListNode*) malloc(sizeof(WrapSrcListNode));
			yyval.list->node = yystack.l_mark[0].sym;
			yyval.list->next = yystack.l_mark[-2].list;
		} else {
			yyval.list = yystack.l_mark[-2].list;
		}
	}
#line 2470 "y.tab.c"
break;
case 40:
#line 1010 "wrapit.y"
	{
		yystack.l_mark[0].sym->u.farg->n_dims = 1;
		yystack.l_mark[0].sym->u.farg->dim_sizes[0] = 1;
		yyval.sym = yystack.l_mark[0].sym;
	}
#line 2479 "y.tab.c"
break;
case 41:
#line 1016 "wrapit.y"
	{
		yystack.l_mark[-2].sym->u.farg->n_dims = 1;
		yystack.l_mark[-2].sym->u.farg->dim_sizes[0] = yystack.l_mark[0].integer;
		yyval.sym = yystack.l_mark[-2].sym;
	}
#line 2488 "y.tab.c"
break;
case 42:
#line 1022 "wrapit.y"
	{
		yystack.l_mark[-4].sym->u.farg->n_dims = 1;
		yystack.l_mark[-4].sym->u.farg->dim_sizes[0] = -1;
		yyval.sym = yystack.l_mark[-4].sym;
	}
#line 2497 "y.tab.c"
break;
case 43:
#line 1028 "wrapit.y"
	{
		int n_dims=0;
		int i;
		WrapSrcListNode* tmp;
		tmp = yystack.l_mark[-1].list;
		while(tmp != NULL) {
			n_dims++;
			tmp = tmp->next;
		}
		yystack.l_mark[-3].sym->u.farg->n_dims = n_dims;
		tmp = yystack.l_mark[-1].list;
		for(i = 0; i < n_dims; i++) {
			if(((DimVal*)tmp->node)->kind) {
				yystack.l_mark[-3].sym->u.farg->dim_sizes[i]  = -1;
				yystack.l_mark[-3].sym->u.farg->dim_refs[i] = ((DimVal*)tmp->node)->u.sym;
			} else {
				yystack.l_mark[-3].sym->u.farg->dim_refs[i]  = NULL;
				yystack.l_mark[-3].sym->u.farg->dim_sizes[i] = ((DimVal*)tmp->node)->u.val;
			}
			tmp = tmp->next;
		}
		yyval.sym = yystack.l_mark[-3].sym;
	}
#line 2524 "y.tab.c"
break;
case 44:
#line 1052 "wrapit.y"
	{
		yyval.sym = NULL;
	}
#line 2531 "y.tab.c"
break;
case 45:
#line 1056 "wrapit.y"
	{
		yyval.sym = NULL;
	}
#line 2538 "y.tab.c"
break;
case 46:
#line 1060 "wrapit.y"
	{
		yyval.sym = NULL;
	}
#line 2545 "y.tab.c"
break;
case 47:
#line 1066 "wrapit.y"
	{
		yyval.list = (WrapSrcListNode*)malloc(sizeof(WrapSrcListNode));
		yyval.list->node = yystack.l_mark[0].dim;
		yyval.list->next = NULL;
	}
#line 2554 "y.tab.c"
break;
case 48:
#line 1072 "wrapit.y"
	{
		yyval.list = (WrapSrcListNode*)malloc(sizeof(WrapSrcListNode));
		yyval.list->node = yystack.l_mark[0].dim;
		yyval.list->next = yystack.l_mark[-2].list;
	}
#line 2563 "y.tab.c"
break;
case 49:
#line 1080 "wrapit.y"
	{
		yyval.dim = (DimVal*)malloc(sizeof(DimVal));
		yyval.dim->kind = 1;
		yyval.dim->u.sym = yystack.l_mark[0].sym;
	}
#line 2572 "y.tab.c"
break;
case 50:
#line 1086 "wrapit.y"
	{
		yyval.dim = (DimVal*)malloc(sizeof(DimVal));
		yyval.dim->kind = 0;
		yyval.dim->u.val = yystack.l_mark[0].integer;
	}
#line 2581 "y.tab.c"
break;
case 51:
#line 1092 "wrapit.y"
	{
		yyval.dim = (DimVal*)malloc(sizeof(DimVal));
		yyval.dim->kind = 0;
		yyval.dim->u.val = -1;
	}
#line 2590 "y.tab.c"
break;
case 52:
#line 1100 "wrapit.y"
	{
		yyval.ftyp = NULL;
	}
#line 2597 "y.tab.c"
break;
case 53:
#line 1104 "wrapit.y"
	{
		if(yystack.l_mark[0].ftyp->datatype == NCL_none) {
			fprintf(stderr,"Unsupported FORTRAN type detected\n");
		}
		yyval.ftyp = yystack.l_mark[0].ftyp;
	}
#line 2607 "y.tab.c"
break;
case 54:
#line 1114 "wrapit.y"
	{
	}
#line 2613 "y.tab.c"
break;
case 55:
#line 1117 "wrapit.y"
	{
	}
#line 2619 "y.tab.c"
break;
case 56:
#line 1120 "wrapit.y"
	{
	}
#line 2625 "y.tab.c"
break;
case 57:
#line 1125 "wrapit.y"
	{
		WrapSrcListNode* tmp;
		NclSymbol *s;

		tmp = yystack.l_mark[-3].list;

		while(tmp!= NULL) {
			s = (NclSymbol*)tmp->node;		
			s->u.wparam->getarg->totalp = w_nargs;
			tmp = tmp->next;
		}
		yystack.l_mark[-5].sym->type = PROC;
		current->f_or_p = 0;
		current->c_defstring = malloc(strlen(yystack.l_mark[-5].sym->name)+1);
		strcpy(current->c_defstring,yystack.l_mark[-5].sym->name);

	}
#line 2646 "y.tab.c"
break;
case 58:
#line 1143 "wrapit.y"
	{
		WrapSrcListNode* tmp;
		NclSymbol *s;

		tmp = yystack.l_mark[-3].list;

		while(tmp!= NULL) {
			s = (NclSymbol*)tmp->node;		
			s->u.wparam->getarg->totalp = w_nargs;
			tmp = tmp->next;
		}
		yystack.l_mark[-5].sym->type = FUNC;
		current->f_or_p = 1;
		current->c_defstring = malloc(strlen(yystack.l_mark[-5].sym->name)+1);
		strcpy(current->c_defstring,yystack.l_mark[-5].sym->name);
	}
#line 2666 "y.tab.c"
break;
case 59:
#line 1160 "wrapit.y"
	{
		yystack.l_mark[-3].sym->type = PROC;
		current->f_or_p = 0;
		current->c_defstring = malloc(strlen(yystack.l_mark[-3].sym->name)+1);
		strcpy(current->c_defstring,yystack.l_mark[-3].sym->name);
	}
#line 2676 "y.tab.c"
break;
case 60:
#line 1167 "wrapit.y"
	{
		yystack.l_mark[-4].sym->type = FUNC;
		current->f_or_p = 1;
		current->c_defstring = malloc(strlen(yystack.l_mark[-4].sym->name)+1);
		strcpy(current->c_defstring,yystack.l_mark[-4].sym->name);
	}
#line 2686 "y.tab.c"
break;
case 61:
#line 1176 "wrapit.y"
	{
		yyval.list = (WrapSrcListNode*)malloc(sizeof(WrapSrcListNode));
		yyval.list->next = NULL;
		yyval.list->node = (void*)yystack.l_mark[0].sym;
	}
#line 2695 "y.tab.c"
break;
case 62:
#line 1182 "wrapit.y"
	{
		yyval.list = (WrapSrcListNode*)malloc(sizeof(WrapSrcListNode));
		yyval.list->next = yystack.l_mark[-2].list;
		yyval.list->node = (void*)yystack.l_mark[0].sym;
	}
#line 2704 "y.tab.c"
break;
case 63:
#line 1188 "wrapit.y"
	{
		WGetArgValue *tmp;
		char buffer[BUFFSIZE];
		yystack.l_mark[0].sym->type = WPARAM;	
		yystack.l_mark[0].sym->u.wparam = malloc(sizeof(WParamInfo));
		yystack.l_mark[0].sym->u.wparam->n_dims = -1;
		yystack.l_mark[0].sym->u.wparam->dim_sizes[0] = -1;
		yystack.l_mark[0].sym->u.wparam->datatype = -1;
		yystack.l_mark[0].sym->u.wparam->getarg = tmp = WNewArgVal();
		tmp->assign_to = yystack.l_mark[0].sym->name;
		tmp->pnum = w_nargs;
		tmp->datatype = -1;
		tmp->rw = 1;
		yyval.sym = yystack.l_mark[0].sym;
		(void)WNewVDef(yystack.l_mark[0].sym->name,-1,1,NULL,0);
		w_nargs++;
	}
#line 2725 "y.tab.c"
break;
case 64:
#line 1206 "wrapit.y"
	{
		WGetArgValue *tmp;
		WSrcList *srclist;
		char buffer[BUFFSIZE];

		yystack.l_mark[-2].sym->type = WPARAM;
		yystack.l_mark[-2].sym->u.wparam = malloc(sizeof(WParamInfo));
		yystack.l_mark[-2].sym->u.wparam->n_dims = -1;
		yystack.l_mark[-2].sym->u.wparam->dim_sizes[0] = -1;
		yystack.l_mark[-2].sym->u.wparam->datatype = yystack.l_mark[0].integer;
		yystack.l_mark[-2].sym->u.wparam->getarg = tmp = WNewArgVal();
		(void)WNewVDef(yystack.l_mark[-2].sym->name,yystack.l_mark[0].integer,1,NULL,0);

		tmp->assign_to = yystack.l_mark[-2].sym->name;
		tmp->pnum = w_nargs;
		tmp->datatype = yystack.l_mark[0].integer;
		tmp->rw = 1;
                sprintf(buffer,"&%s_type",yystack.l_mark[-2].sym->name);
                tmp->type = malloc(strlen(buffer)+1);
                strcpy(tmp->type,buffer);


		sprintf(buffer,"%s_type",yystack.l_mark[-2].sym->name);
		(void)WNewVDef(buffer,NCL_int,0,NULL,0);

		yyval.sym = yystack.l_mark[-2].sym;
		w_nargs++;
	}
#line 2757 "y.tab.c"
break;
case 65:
#line 1235 "wrapit.y"
	{	
		WGetArgValue *tmp;
		char buffer[BUFFSIZE];
		IntList *itmp;
		int i = 0 ;

		yystack.l_mark[-1].sym->type = WPARAM;
		yystack.l_mark[-1].sym->u.wparam = malloc(sizeof(WParamInfo));
		itmp = yystack.l_mark[0].ilist;
		while(itmp != NULL) {
			yystack.l_mark[-1].sym->u.wparam->dim_sizes[i] = itmp->val;	
			i++;
			itmp = itmp->next;
		}
		yystack.l_mark[-1].sym->u.wparam->n_dims = i;
		yystack.l_mark[-1].sym->u.wparam->datatype = -1;
		yystack.l_mark[-1].sym->u.wparam->getarg = tmp = WNewArgVal();
		sprintf(buffer,"%s",yystack.l_mark[-1].sym->name);
		(void)WNewVDef(buffer,-1,1,NULL,0);

		tmp->assign_to = yystack.l_mark[-1].sym->name;
		tmp->pnum = w_nargs;
		tmp->datatype = -1;
		tmp->rw = 1;

		sprintf(buffer,"&%s_ndims",yystack.l_mark[-1].sym->name);
		tmp->ndims = malloc(strlen(buffer)+1);
		strcpy(tmp->ndims,buffer);


		sprintf(buffer,"%s_ndims",yystack.l_mark[-1].sym->name);
		(void)WNewVDef(buffer,NCL_int,0,NULL,0);

		sprintf(buffer,"%s_dimsizes",yystack.l_mark[-1].sym->name);
		(void)WNewVDef(buffer,NCL_long,0,"[NCL_MAX_DIMENSIONS]",0);
		tmp->dimsizes = malloc(strlen(buffer)+1);
		strcpy(tmp->dimsizes,buffer);


		yyval.sym = yystack.l_mark[-1].sym;
		w_nargs++;
	}
#line 2803 "y.tab.c"
break;
case 66:
#line 1278 "wrapit.y"
	{	
		WGetArgValue *tmp;
		char buffer[BUFFSIZE];
		IntList *itmp;
		int i = 0 ;
		yystack.l_mark[-3].sym->type = WPARAM;
		yystack.l_mark[-3].sym->u.wparam = malloc(sizeof(WParamInfo));
		itmp = yystack.l_mark[-2].ilist;
		while(itmp != NULL) {
			yystack.l_mark[-3].sym->u.wparam->dim_sizes[i] = itmp->val;	
			i++;
			itmp = itmp->next;
		}
		yystack.l_mark[-3].sym->u.wparam->n_dims = i;
		yystack.l_mark[-3].sym->u.wparam->datatype = yystack.l_mark[0].integer;
		yystack.l_mark[-3].sym->u.wparam->getarg = tmp = WNewArgVal();
		sprintf(buffer,"%s",yystack.l_mark[-3].sym->name);
		(void)WNewVDef(buffer,yystack.l_mark[0].integer,1,NULL,0);

		tmp->assign_to = yystack.l_mark[-3].sym->name;
		tmp->pnum = w_nargs;
		tmp->datatype = yystack.l_mark[0].integer;
		tmp->rw = 1;

		sprintf(buffer,"&%s_ndims",yystack.l_mark[-3].sym->name);	
		tmp->ndims = malloc(strlen(buffer)+1);
		strcpy(tmp->ndims,buffer);
		sprintf(buffer,"%s_ndims",yystack.l_mark[-3].sym->name);
		(void)WNewVDef(buffer,NCL_int,0,NULL,0);


		sprintf(buffer,"%s_dimsizes",yystack.l_mark[-3].sym->name);
		tmp->dimsizes= malloc(strlen(buffer)+1);
		strcpy(tmp->dimsizes,buffer);
		(void)WNewVDef(buffer,NCL_long,0,"[NCL_MAX_DIMENSIONS]",0);

		sprintf(buffer,"&%s_type",yystack.l_mark[-3].sym->name);
		tmp->type = malloc(strlen(buffer)+1);
		strcpy(tmp->type,buffer);

		sprintf(buffer,"%s_type",yystack.l_mark[-3].sym->name);
		(void)WNewVDef(buffer,NCL_int,0,NULL,0);

		yyval.sym = yystack.l_mark[-3].sym;
		w_nargs++;
	}
#line 2853 "y.tab.c"
break;
case 67:
#line 1326 "wrapit.y"
	{
                yyval.ilist = (IntList*) malloc(sizeof(IntList));
                yyval.ilist->val = yystack.l_mark[-1].integer;
                yyval.ilist->next = NULL;
	}
#line 2862 "y.tab.c"
break;
case 68:
#line 1332 "wrapit.y"
	{
                yyval.ilist = (IntList*) malloc(sizeof(IntList));
                yyval.ilist->val = -1;
                yyval.ilist->next = NULL;
	}
#line 2871 "y.tab.c"
break;
case 69:
#line 1338 "wrapit.y"
	{
                yyval.ilist = (IntList*) malloc(sizeof(IntList));
                yyval.ilist->val = -1;
                yyval.ilist->next = yystack.l_mark[-3].ilist;
	}
#line 2880 "y.tab.c"
break;
case 70:
#line 1344 "wrapit.y"
	{
                yyval.ilist = (IntList*) malloc(sizeof(IntList));
                yyval.ilist->val = yystack.l_mark[-1].integer;
                yyval.ilist->next = yystack.l_mark[-3].ilist;
	}
#line 2889 "y.tab.c"
break;
case 71:
#line 1351 "wrapit.y"
	{ yyval.integer = NCL_float; }
#line 2894 "y.tab.c"
break;
case 72:
#line 1352 "wrapit.y"
	{ yyval.integer = NCL_long; }
#line 2899 "y.tab.c"
break;
case 73:
#line 1353 "wrapit.y"
	{ yyval.integer = NCL_int; }
#line 2904 "y.tab.c"
break;
case 74:
#line 1354 "wrapit.y"
	{ yyval.integer = NCL_short; }
#line 2909 "y.tab.c"
break;
case 75:
#line 1355 "wrapit.y"
	{ yyval.integer = NCL_double; }
#line 2914 "y.tab.c"
break;
case 76:
#line 1356 "wrapit.y"
	{ yyval.integer = NCL_char; }
#line 2919 "y.tab.c"
break;
case 77:
#line 1357 "wrapit.y"
	{ yyval.integer = NCL_byte; }
#line 2924 "y.tab.c"
break;
case 78:
#line 1358 "wrapit.y"
	{ yyval.integer = NCL_string; }
#line 2929 "y.tab.c"
break;
case 79:
#line 1359 "wrapit.y"
	{ yyval.integer = NCL_logical; }
#line 2934 "y.tab.c"
break;
case 80:
#line 1364 "wrapit.y"
	{
		yyval.list = (WrapSrcListNode*) malloc(sizeof(WrapSrcListNode));
		yyval.list->node = (void*)yystack.l_mark[-1].src_node;
		yyval.list->next = NULL;
	}
#line 2943 "y.tab.c"
break;
case 81:
#line 1370 "wrapit.y"
	{
		yyval.list = (WrapSrcListNode*) malloc(sizeof(WrapSrcListNode));
		yyval.list->node = (void*)yystack.l_mark[-1].src_node;
		yyval.list->next = yystack.l_mark[-2].list;
	}
#line 2952 "y.tab.c"
break;
case 82:
#line 1377 "wrapit.y"
	{
	}
#line 2958 "y.tab.c"
break;
case 83:
#line 1379 "wrapit.y"
	{theparam = yystack.l_mark[0].ploc;}
#line 2963 "y.tab.c"
break;
case 84:
#line 1379 "wrapit.y"
	{
		
	}
#line 2970 "y.tab.c"
break;
case 85:
#line 1385 "wrapit.y"
	{
		char buffer[BUFFSIZE];
		WParamLoc *loc = (WParamLoc*)malloc(sizeof(WParamLoc));
		NclSymbol *s = _NclLookUpInScope(current->crec,yystack.l_mark[0].sym->name);
		int i;

		loc->type = RETURNPARAM;
		loc->datatype = yystack.l_mark[0].sym->u.wparam->datatype;
		loc->xfarg = NULL;
		loc->cdef = s->u.centry;
		loc->wsym = yystack.l_mark[0].sym;
		
		if(yystack.l_mark[0].sym->u.wparam->n_dims == -1) {
			loc->typeofdim = 1;
			loc->n_dims = 1;
			sprintf(buffer,"%s_dimsizes",yystack.l_mark[0].sym->name);	
			s = _NclLookUpInScope(current->crec,buffer);
			loc->altdimsref = s->u.centry;
			sprintf(loc->altndimref,"%s_ndims",yystack.l_mark[0].sym->name);
		} else {
			loc->typeofdim = 0;
			loc->n_dims = yystack.l_mark[0].sym->u.wparam->n_dims;
			for(i = 0; i < yystack.l_mark[0].sym->u.wparam->n_dims; i++) {
				loc->dim_sizes[i] = yystack.l_mark[0].sym->u.wparam->dim_sizes[i];
				if(loc->dim_sizes[i] = -1) {
					sprintf(loc->dim_refs[i],"(%s_dimsizes[%d])",yystack.l_mark[0].sym->name,i);
				} else {
					sprintf(loc->dim_refs[i],"(%d)",loc->dim_sizes[i]);
				}
			}
		}
		yyval.ploc = loc;
	}
#line 3007 "y.tab.c"
break;
case 86:
#line 1419 "wrapit.y"
	{
	}
#line 3013 "y.tab.c"
break;
case 87:
#line 1422 "wrapit.y"
	{
	}
#line 3019 "y.tab.c"
break;
case 88:
#line 1425 "wrapit.y"
	{
        }
#line 3025 "y.tab.c"
break;
case 89:
#line 1445 "wrapit.y"
	{
		yyval.list = (WrapSrcListNode*) malloc(sizeof(WrapSrcListNode));
		yyval.list->node = (void*)yystack.l_mark[-1].src_node;
		yyval.list->next = NULL;
	}
#line 3034 "y.tab.c"
break;
case 90:
#line 1451 "wrapit.y"
	{
		yyval.list = (WrapSrcListNode*) malloc(sizeof(WrapSrcListNode));
		yyval.list->node = (void*)yystack.l_mark[-1].src_node;
		yyval.list->next = yystack.l_mark[-2].list;
	}
#line 3043 "y.tab.c"
break;
case 91:
#line 1458 "wrapit.y"
	{ theparam = yystack.l_mark[0].ploc; }
#line 3048 "y.tab.c"
break;
case 92:
#line 1459 "wrapit.y"
	{
		char buffer[BUFFSIZE];
		int i,j;
		WSrcList *tmp;
		WModList *mods;


		switch(yystack.l_mark[-2].ploc->type) {
		case FARGNEW:
			current->c_callrec->arg_strings[yystack.l_mark[-2].ploc->xfarg->u.xref->u.farg->arg_num] = yystack.l_mark[-2].ploc->cdef;
			sprintf(buffer,"\t%s = (%s*)malloc(sizeof(%s)",yystack.l_mark[-2].ploc->cdef->string,CType(yystack.l_mark[-2].ploc->datatype),CType(yystack.l_mark[-2].ploc->datatype));
			for(i = 0; i < yystack.l_mark[-2].ploc->n_dims; i++) {
				strcat(buffer," * ");
				strcat(buffer,yystack.l_mark[-2].ploc->dim_refs[i]);
			}
			strcat(buffer,");\n");
			if(yystack.l_mark[-2].ploc->cdef->additional_src == NULL) {
				yystack.l_mark[-2].ploc->cdef->additional_src = WNewAdditionalSrc(buffer,1);
			} else {
				tmp =  WNewAdditionalSrc(buffer,1);
				tmp->next = yystack.l_mark[-2].ploc->cdef->additional_src;
				yystack.l_mark[-2].ploc->cdef->additional_src = tmp;
			}
			break;
		case PARAMVAL:
		case TOTALPARAM:
			current->c_callrec->arg_strings[yystack.l_mark[-2].ploc->xfarg->u.xref->u.farg->arg_num] = yystack.l_mark[-2].ploc->cdef;
			break;
		case DIMSPARAM:
			break;
		case DIMINDEXPARAM:
			break;
		}

	}
#line 3087 "y.tab.c"
break;
case 93:
#line 1497 "wrapit.y"
	{
		WParamLoc *loc = NewParamLoc(yystack.l_mark[-4].sym);
		char buffer[BUFFSIZE];
		WDSpecList *tmp = yystack.l_mark[0].dsp;
		WCentry *ctmp;
		int j;
	
		loc->type = FARGNEW;
		loc->xfarg = yystack.l_mark[-4].sym;
		loc->cdef = WNewVDef(yystack.l_mark[-4].sym->name,yystack.l_mark[-4].sym->u.xref->u.farg->datatype,1,NULL,1);
		sprintf(loc->call_string,"%s",yystack.l_mark[-4].sym->name);

		loc->n_dims = 0	;
		while(tmp != NULL) {

			switch(tmp->type) {
			case INTDIMSIZES:
				sprintf(loc->dim_refs[loc->n_dims],"(%d)",tmp->u.val);
				loc->n_dims++;
				break;
			case PARAMVALDIMSIZES:
				sprintf(loc->dim_refs[loc->n_dims],"(*%s)",tmp->u.pval.wsym->name);
				loc->n_dims++;
				break;
			case TOTALPARAMDIMSIZES:
				sprintf(loc->dim_refs[loc->n_dims],"(%s_total)",tmp->u.tpval.wsym->name);
				loc->n_dims++;
				break;
			case DIMSPARAMDIMSIZES:
				if(tmp->u.dpval.wsym->u.wparam->n_dims == -1) {
					DoTotal(tmp->u.dpval.wsym);
					sprintf(loc->dim_refs[loc->n_dims],"(%s_total)",tmp->u.dpval.wsym->name);
					loc->n_dims++;
				} else {
					for(j = 0; j < tmp->u.dpval.wsym->u.wparam->n_dims; j++) {
						sprintf(loc->dim_refs[loc->n_dims],"(%s_dimsizes[%d])",tmp->u.dpval.wsym->name,j);	
						loc->n_dims++;
					}
				}
				break;
			case DIMINDEXPARAMDIMSIZES:
				sprintf(loc->dim_refs[loc->n_dims],"(%s_dimsizes[%d])",tmp->u.dipval.wsym->name,tmp->u.dipval.index);	
				loc->n_dims++;
				break;
			}
			tmp = tmp->next;
		}
		yyval.ploc = loc;
	}
#line 3140 "y.tab.c"
break;
case 94:
#line 1547 "wrapit.y"
	{

		WParamLoc *loc = NewParamLoc(yystack.l_mark[-2].sym);
		NclSymbol *tmp;
		int i;
		char buffer[BUFFSIZE];

		DoDimsizes(yystack.l_mark[0].sym);
		loc->type = PARAMVAL;
		loc->xfarg = yystack.l_mark[-2].sym;
		tmp = _NclLookUpInScope(current->crec,yystack.l_mark[0].sym->name);
		loc->cdef = tmp->u.centry;
		sprintf(loc->call_string,"%s",yystack.l_mark[0].sym->name);
		loc->n_dims = yystack.l_mark[0].sym->u.wparam->n_dims;
		for(i = 0; i < yystack.l_mark[0].sym->u.wparam->n_dims; i++) {
			loc->dim_sizes[i] = yystack.l_mark[0].sym->u.wparam->dim_sizes[i];
			sprintf(loc->dim_refs[i],"(%s_dimsizes[%d])",tmp->name,i);
		}
		loc->datatype = yystack.l_mark[0].sym->u.wparam->datatype;
		yyval.ploc = loc;
		
	}
#line 3166 "y.tab.c"
break;
case 95:
#line 1570 "wrapit.y"
	{
		WParamLoc *loc = NewParamLoc(yystack.l_mark[-3].sym);
		WCentry *tmp;
		char buffer[BUFFSIZE];
		NclSymbol *s;

		DoTotal(yystack.l_mark[0].sym);
		loc->type = TOTALPARAM;
		loc->xfarg = yystack.l_mark[-3].sym;
		loc->n_dims = 1;
		loc->datatype = NCL_int;
		loc->dim_sizes[0] = 1;
		sprintf(loc->dim_refs[0],"(1)");
		sprintf(buffer,"%s_total",yystack.l_mark[0].sym->name);
		s = _NclLookUpInScope(current->crec,buffer);
		loc->cdef = s->u.centry;
		sprintf(loc->call_string,"&%s",buffer);
		yyval.ploc = loc;
	}
#line 3189 "y.tab.c"
break;
case 96:
#line 1590 "wrapit.y"
	{
                WParamLoc *loc = NewParamLoc(yystack.l_mark[-3].sym);
		char buffer[BUFFSIZE];
		NclSymbol *s;
		DoDimsizes(yystack.l_mark[0].sym);

                loc->type = DIMSPARAM;
                loc->xfarg = yystack.l_mark[-3].sym;
		loc->n_dims = 1;
		loc->datatype = NCL_int;
		loc->dim_sizes[0] = yystack.l_mark[0].sym->u.wparam->n_dims;
		sprintf(loc->dim_refs[0],"(%d)",yystack.l_mark[0].sym->u.wparam->n_dims);
		sprintf(buffer,"%s_dimsizes",yystack.l_mark[0].sym->name);
		s = _NclLookUpInScope(current->crec,buffer);
                loc->cdef = s->u.centry;
		sprintf(loc->call_string,"%s",buffer);
		yyval.ploc = loc;

	}
#line 3212 "y.tab.c"
break;
case 97:
#line 1610 "wrapit.y"
	{
                WParamLoc *loc = NewParamLoc(yystack.l_mark[-6].sym);
		char buffer[BUFFSIZE];
		NclSymbol *s;

		DoDimsizes(yystack.l_mark[-3].sym);

                loc->type = DIMINDEXPARAM;
                loc->xfarg = yystack.l_mark[-6].sym;
		loc->n_dims = 1;
		loc->dim_sizes[0] = 1;
		sprintf(loc->dim_refs[0],"(1)");
		sprintf(buffer,"%s_dimsizes",yystack.l_mark[-3].sym->name);
		s = _NclLookUpInScope(current->crec,buffer);
                loc->cdef = s->u.centry;
		sprintf(loc->call_string,"&(%s[%d])",buffer,yystack.l_mark[-1].integer);
		yyval.ploc = loc;
	}
#line 3234 "y.tab.c"
break;
case 98:
#line 1645 "wrapit.y"
	{
		yyval.dsp = (WDSpecList*)malloc(sizeof(WDSpecList));
		yyval.dsp->type = INTDIMSIZES;
		yyval.dsp->u.val = yystack.l_mark[0].integer;
		yyval.dsp->next = NULL;
	}
#line 3244 "y.tab.c"
break;
case 99:
#line 1652 "wrapit.y"
	{
		yyval.dsp = (WDSpecList*)malloc(sizeof(WDSpecList));
		yyval.dsp->type = PARAMVALDIMSIZES;
		yyval.dsp->u.pval.wsym = yystack.l_mark[0].sym;
		yyval.dsp->next = NULL;
	}
#line 3254 "y.tab.c"
break;
case 100:
#line 1659 "wrapit.y"
	{
		char buffer[BUFFSIZE];
		WCentry *tmp;
		yyval.dsp = (WDSpecList*)malloc(sizeof(WDSpecList));
		yyval.dsp->type = TOTALPARAMDIMSIZES;
		yyval.dsp->u.tpval.wsym = yystack.l_mark[0].sym;
		yyval.dsp->next = NULL;
		DoTotal(yystack.l_mark[0].sym);
	}
#line 3267 "y.tab.c"
break;
case 101:
#line 1669 "wrapit.y"
	{
		char buffer[BUFFSIZE];
		yyval.dsp = (WDSpecList*)malloc(sizeof(WDSpecList));
		yyval.dsp->type = DIMSPARAMDIMSIZES;
		yyval.dsp->u.dpval.wsym = yystack.l_mark[0].sym;
		yyval.dsp->next = NULL;
		DoDimsizes(yystack.l_mark[0].sym);
	}
#line 3279 "y.tab.c"
break;
case 102:
#line 1678 "wrapit.y"
	{
		char buffer[BUFFSIZE];
		yyval.dsp = (WDSpecList*)malloc(sizeof(WDSpecList));
		yyval.dsp->type = DIMINDEXPARAMDIMSIZES;
		yyval.dsp->u.dipval.wsym = yystack.l_mark[-3].sym;
		yyval.dsp->u.dipval.index= yystack.l_mark[-1].integer;
		yyval.dsp->next = NULL;
		DoDimsizes(yystack.l_mark[-3].sym);
	}
#line 3292 "y.tab.c"
break;
case 103:
#line 1688 "wrapit.y"
	{
		char buffer[BUFFSIZE];
		yyval.dsp = (WDSpecList*)malloc(sizeof(WDSpecList));
		yyval.dsp->type = PARAMVALDIMSIZES;
		yyval.dsp->u.pval.wsym = yystack.l_mark[0].sym;
		yyval.dsp->next = yystack.l_mark[-2].dsp;
	}
#line 3303 "y.tab.c"
break;
case 104:
#line 1696 "wrapit.y"
	{
		char buffer[BUFFSIZE];
		WCentry *tmp;
		yyval.dsp = (WDSpecList*)malloc(sizeof(WDSpecList));
		yyval.dsp->type = TOTALPARAMDIMSIZES;
		yyval.dsp->u.pval.wsym = yystack.l_mark[0].sym;
		yyval.dsp->next = yystack.l_mark[-3].dsp;
		DoTotal(yystack.l_mark[0].sym);
	}
#line 3316 "y.tab.c"
break;
case 105:
#line 1706 "wrapit.y"
	{
		char buffer[BUFFSIZE];
		yyval.dsp = (WDSpecList*)malloc(sizeof(WDSpecList));
		yyval.dsp->type = DIMSPARAMDIMSIZES;
		yyval.dsp->u.dpval.wsym = yystack.l_mark[0].sym;
		yyval.dsp->next = yystack.l_mark[-3].dsp;
		DoDimsizes(yystack.l_mark[0].sym);
	}
#line 3328 "y.tab.c"
break;
case 106:
#line 1715 "wrapit.y"
	{
		char buffer[BUFFSIZE];
		yyval.dsp = (WDSpecList*)malloc(sizeof(WDSpecList));
		yyval.dsp->type = DIMINDEXPARAMDIMSIZES;
		yyval.dsp->u.dipval.wsym = yystack.l_mark[-3].sym;
		yyval.dsp->u.dipval.index= yystack.l_mark[-1].integer;
		yyval.dsp->next = yystack.l_mark[-6].dsp;
		DoDimsizes(yystack.l_mark[-3].sym);
	}
#line 3341 "y.tab.c"
break;
case 107:
#line 1725 "wrapit.y"
	{
		char buffer[BUFFSIZE];
		yyval.dsp = (WDSpecList*)malloc(sizeof(WDSpecList));
		yyval.dsp->type = INTDIMSIZES;
		yyval.dsp->u.val = yystack.l_mark[0].integer;
		yyval.dsp->next = yystack.l_mark[-2].dsp;
	}
#line 3352 "y.tab.c"
break;
case 108:
#line 1761 "wrapit.y"
	{
		yyval.dsp = (WDSpecList*)malloc(sizeof(WDSpecList));
		yyval.dsp->type = PARAMVALDIMSIZES;
		yyval.dsp->u.pval.wsym = yystack.l_mark[0].sym;
		yyval.dsp->next = NULL;
	}
#line 3362 "y.tab.c"
break;
case 109:
#line 1768 "wrapit.y"
	{
		char buffer[BUFFSIZE];
		WCentry *tmp;
		yyval.dsp = (WDSpecList*)malloc(sizeof(WDSpecList));
		yyval.dsp->type = TOTALPARAMDIMSIZES;
		yyval.dsp->u.tpval.wsym = yystack.l_mark[0].sym;
		yyval.dsp->next = NULL;
		DoTotal(yystack.l_mark[0].sym);
	}
#line 3375 "y.tab.c"
break;
case 110:
#line 1778 "wrapit.y"
	{
		char buffer[BUFFSIZE];
		yyval.dsp = (WDSpecList*)malloc(sizeof(WDSpecList));
		yyval.dsp->type = DIMSPARAMDIMSIZES;
		yyval.dsp->u.dpval.wsym = yystack.l_mark[0].sym;
		yyval.dsp->next = NULL;
		DoDimsizes(yystack.l_mark[0].sym);
	}
#line 3387 "y.tab.c"
break;
case 111:
#line 1787 "wrapit.y"
	{
		char buffer[BUFFSIZE];
		yyval.dsp = (WDSpecList*)malloc(sizeof(WDSpecList));
		yyval.dsp->type = DIMINDEXPARAMDIMSIZES;
		yyval.dsp->u.dipval.wsym = yystack.l_mark[-3].sym;
		yyval.dsp->u.dipval.index= yystack.l_mark[-1].integer;
		yyval.dsp->next = NULL;
		DoDimsizes(yystack.l_mark[-3].sym);
	}
#line 3400 "y.tab.c"
break;
case 112:
#line 1797 "wrapit.y"
	{
	}
#line 3406 "y.tab.c"
break;
case 113:
#line 1800 "wrapit.y"
	{
        }
#line 3412 "y.tab.c"
break;
case 114:
#line 1803 "wrapit.y"
	{
        }
#line 3418 "y.tab.c"
break;
case 115:
#line 1806 "wrapit.y"
	{
        }
#line 3424 "y.tab.c"
break;
case 116:
#line 1826 "wrapit.y"
	{
		yyval.mod = NULL;
	}
#line 3431 "y.tab.c"
break;
case 117:
#line 1830 "wrapit.y"
	{
		yyval.mod= yystack.l_mark[0].mod;
	}
#line 3438 "y.tab.c"
break;
case 118:
#line 1836 "wrapit.y"
	{
		yystack.l_mark[0].mod->next = NULL;
		yyval.mod = yystack.l_mark[0].mod;
	}
#line 3446 "y.tab.c"
break;
case 119:
#line 1841 "wrapit.y"
	{
		yystack.l_mark[0].mod->next = yystack.l_mark[-2].mod;
		yyval.mod = yystack.l_mark[0].mod;
	}
#line 3454 "y.tab.c"
break;
case 120:
#line 1848 "wrapit.y"
	{
		yyval.mod = NULL;
	}
#line 3461 "y.tab.c"
break;
case 121:
#line 1852 "wrapit.y"
	{
		int i;
		char buffer[BUFFSIZE];
		NclSymbol *s;

		yyval.mod = (WModList*)malloc(sizeof(WModList));
		yyval.mod->type = DIMSIZESOF;
		switch(yystack.l_mark[0].dsp->type) {
		case PARAMVALDIMSIZES:
			yyval.mod->u.dims.sym = yystack.l_mark[0].dsp->u.pval.wsym;
			yyval.mod->u.dims.index = -1;
			yyval.mod->u.dims.kind = 0;
			if(yystack.l_mark[0].dsp->u.pval.wsym->u.wparam->n_dims == 1) {
				if(yystack.l_mark[0].dsp->u.pval.wsym->u.wparam->dim_sizes[0] != -1) {
					theparam->typeofdim = 0;
					theparam->n_dims = yystack.l_mark[0].dsp->u.pval.wsym->u.wparam->dim_sizes[0];
					for(i = 0; i < yystack.l_mark[0].dsp->u.pval.wsym->u.wparam->dim_sizes[0]; i++) {
						sprintf(theparam->dim_refs[i],"(%s[%d])",yystack.l_mark[0].dsp->u.pval.wsym->name);
						theparam->dim_sizes[i] = -1;
					}
				} else {
					theparam->n_dims = 1;
					theparam->dim_sizes[0] = -1;
					theparam->typeofdim = 1;
					sprintf(buffer,"%s",yystack.l_mark[0].dsp->u.pval.wsym->name);
					s = _NclLookUpInScope(current->crec,buffer);
					theparam->altdimsref = s->u.centry; 

					sprintf(theparam->altndimref,"%s_dimsizes[0]",yystack.l_mark[0].dsp->u.pval.wsym->name);
				}
			} else if(yystack.l_mark[0].dsp->u.pval.wsym->u.wparam->n_dims == -1) {
				theparam->n_dims = 1;
				theparam->dim_sizes[0] = -1;
				theparam->typeofdim = 1;
                                sprintf(buffer,"%s",yystack.l_mark[0].dsp->u.pval.wsym->name);
                                s = _NclLookUpInScope(current->crec,buffer);
                                theparam->altdimsref = s->u.centry; 
                                sprintf(theparam->altndimref,"%s_dimsizes[0]",yystack.l_mark[0].dsp->u.pval.wsym->name); 
			} else {
				fprintf(stderr,"Can not use a multidimensional variable (%s) to specify dimension sizes",yystack.l_mark[0].dsp->u.pval.wsym->name);
			}
		break;
		case DIMSPARAMDIMSIZES:
			yyval.mod->u.dims.sym = yystack.l_mark[0].dsp->u.dpval.wsym;
			yyval.mod->u.dims.index = -1;
			yyval.mod->u.dims.kind = 1;
			theparam->typeofdim = 0;
			if(yystack.l_mark[0].dsp->u.dpval.wsym->u.wparam->n_dims != -1) {
				for(i = 0; i <  yystack.l_mark[0].dsp->u.dpval.wsym->u.wparam->n_dims; i++) {
					if(yystack.l_mark[0].dsp->u.dpval.wsym->u.wparam->dim_sizes[i] == -1) {
						sprintf(theparam->dim_refs[i],"(%s_dimsizes[%d])",yystack.l_mark[0].dsp->u.dpval.wsym->name);
						theparam->dim_sizes[i] = -1;
					} else {
						sprintf(theparam->dim_refs[i],"(%d)",yystack.l_mark[0].dsp->u.dpval.wsym->u.wparam->dim_sizes[i]);
						theparam->dim_sizes[i] = yystack.l_mark[0].dsp->u.dpval.wsym->u.wparam->dim_sizes[i];
					}
				}
			} else {
				theparam->n_dims = -1;
				theparam->dim_sizes[0] = -1;
				theparam->typeofdim = 1;
                                sprintf(buffer,"%s_dimsizes",yystack.l_mark[0].dsp->u.dpval.wsym->name);
                                s = _NclLookUpInScope(current->crec,buffer);
                                theparam->altdimsref = s->u.centry;
                                sprintf(theparam->altndimref,"%s_ndims",yystack.l_mark[0].dsp->u.dpval.wsym->name);

			}
		break;
		case TOTALPARAMDIMSIZES:
			yyval.mod->u.dims.sym = yystack.l_mark[0].dsp->u.tpval.wsym;
			yyval.mod->u.dims.index = -1;
			yyval.mod->u.dims.kind = 2;
			theparam->dim_sizes[0] = -1;
			theparam->typeofdim = 0;
			theparam->n_dims = 1;
			sprintf(theparam->dim_refs[0],"(%s_total)",yystack.l_mark[0].dsp->u.tpval.wsym->name);
		break;
		case DIMINDEXPARAMDIMSIZES:
			yyval.mod->u.dims.sym = yystack.l_mark[0].dsp->u.dipval.wsym;
			yyval.mod->u.dims.index = yystack.l_mark[0].dsp->u.dipval.index;
			yyval.mod->u.dims.kind = 3;
			theparam->typeofdim = 0;
			theparam->dim_sizes[0] = yystack.l_mark[0].dsp->u.dpval.wsym->u.wparam->dim_sizes[ yystack.l_mark[0].dsp->u.dipval.index];
			theparam->n_dims = 1;
			sprintf(theparam->dim_refs[0],"(%s_dimsizes[%d])",yystack.l_mark[0].dsp->u.dipval.wsym->name,yystack.l_mark[0].dsp->u.dipval.index);
		break;
		} 

		
	}
#line 3555 "y.tab.c"
break;
case 122:
#line 1943 "wrapit.y"
	{
		yyval.mod = NULL;
	}
#line 3562 "y.tab.c"
break;
case 123:
#line 1947 "wrapit.y"
	{
		yyval.mod = NULL;
	}
#line 3569 "y.tab.c"
break;
case 124:
#line 1951 "wrapit.y"
	{
		yyval.mod = NULL;
	}
#line 3576 "y.tab.c"
break;
case 125:
#line 1955 "wrapit.y"
	{
		yyval.mod = (WModList*)malloc(sizeof(WModList));
		yyval.mod->type = TYPEOF;
		yyval.mod->u.type.datatype = yystack.l_mark[0].integer;
	}
#line 3585 "y.tab.c"
break;
case 126:
#line 1961 "wrapit.y"
	{
		yyval.mod = (WModList*)malloc(sizeof(WModList));
		yyval.mod->type = TYPEOF;
		switch(yystack.l_mark[0].dsp->type) {
		case PARAMVALDIMSIZES:
			yyval.mod->u.type.datatype = yystack.l_mark[0].dsp->u.pval.wsym->u.wparam->datatype;
			theparam->datatype = yystack.l_mark[0].dsp->u.pval.wsym->u.wparam->datatype;
		break;
		case DIMSPARAMDIMSIZES:
			yyval.mod->u.type.datatype = NCL_int;
			theparam->datatype = NCL_int;
		break;
		case TOTALPARAMDIMSIZES:
			yyval.mod->u.type.datatype = NCL_int;
			theparam->datatype = NCL_int;
		break;
		case DIMINDEXPARAMDIMSIZES:
			yyval.mod->u.type.datatype = NCL_int;
			theparam->datatype = NCL_int;
		break;
		} 
	}
#line 3611 "y.tab.c"
break;
case 127:
#line 1984 "wrapit.y"
	{
		yyval.mod = NULL;
	}
#line 3618 "y.tab.c"
break;
case 128:
#line 1988 "wrapit.y"
	{
		yyval.mod = NULL;
	}
#line 3625 "y.tab.c"
break;
case 129:
#line 1992 "wrapit.y"
	{
		yyval.mod = NULL;
	}
#line 3632 "y.tab.c"
break;
case 130:
#line 1996 "wrapit.y"
	{
		yyval.mod = NULL;
	}
#line 3639 "y.tab.c"
break;
#line 3641 "y.tab.c"
    default:
        break;
    }
    yystack.s_mark -= yym;
    yystate = *yystack.s_mark;
    yystack.l_mark -= yym;
#if defined(YYLTYPE) || defined(YYLTYPE_IS_DECLARED)
    yystack.p_mark -= yym;
#endif
    yym = yylhs[yyn];
    if (yystate == 0 && yym == 0)
    {
#if YYDEBUG
        if (yydebug)
        {
            fprintf(stderr, "%s[%d]: after reduction, ", YYDEBUGSTR, yydepth);
#ifdef YYSTYPE_TOSTRING
#if YYBTYACC
            if (!yytrial)
#endif /* YYBTYACC */
                fprintf(stderr, "result is <%s>, ", YYSTYPE_TOSTRING(yystos[YYFINAL], yyval));
#endif
            fprintf(stderr, "shifting from state 0 to final state %d\n", YYFINAL);
        }
#endif
        yystate = YYFINAL;
        *++yystack.s_mark = YYFINAL;
        *++yystack.l_mark = yyval;
#if defined(YYLTYPE) || defined(YYLTYPE_IS_DECLARED)
        *++yystack.p_mark = yyloc;
#endif
        if (yychar < 0)
        {
#if YYBTYACC
            do {
            if (yylvp < yylve)
            {
                /* we're currently re-reading tokens */
                yylval = *yylvp++;
#if defined(YYLTYPE) || defined(YYLTYPE_IS_DECLARED)
                yylloc = *yylpp++;
#endif
                yychar = *yylexp++;
                break;
            }
            if (yyps->save)
            {
                /* in trial mode; save scanner results for future parse attempts */
                if (yylvp == yylvlim)
                {   /* Enlarge lexical value queue */
                    size_t p = (size_t) (yylvp - yylvals);
                    size_t s = (size_t) (yylvlim - yylvals);

                    s += YYLVQUEUEGROWTH;
                    if ((yylexemes = (YYINT *)realloc(yylexemes, s * sizeof(YYINT))) == NULL)
                        goto yyenomem;
                    if ((yylvals   = (YYSTYPE *)realloc(yylvals, s * sizeof(YYSTYPE))) == NULL)
                        goto yyenomem;
#if defined(YYLTYPE) || defined(YYLTYPE_IS_DECLARED)
                    if ((yylpsns   = (YYLTYPE *)realloc(yylpsns, s * sizeof(YYLTYPE))) == NULL)
                        goto yyenomem;
#endif
                    yylvp   = yylve = yylvals + p;
                    yylvlim = yylvals + s;
#if defined(YYLTYPE) || defined(YYLTYPE_IS_DECLARED)
                    yylpp   = yylpe = yylpsns + p;
                    yylplim = yylpsns + s;
#endif
                    yylexp  = yylexemes + p;
                }
                *yylexp = (YYINT) YYLEX;
                *yylvp++ = yylval;
                yylve++;
#if defined(YYLTYPE) || defined(YYLTYPE_IS_DECLARED)
                *yylpp++ = yylloc;
                yylpe++;
#endif
                yychar = *yylexp++;
                break;
            }
            /* normal operation, no conflict encountered */
#endif /* YYBTYACC */
            yychar = YYLEX;
#if YYBTYACC
            } while (0);
#endif /* YYBTYACC */
            if (yychar < 0) yychar = YYEOF;
#if YYDEBUG
            if (yydebug)
            {
                if ((yys = yyname[YYTRANSLATE(yychar)]) == NULL) yys = yyname[YYUNDFTOKEN];
                fprintf(stderr, "%s[%d]: state %d, reading token %d (%s)\n",
                                YYDEBUGSTR, yydepth, YYFINAL, yychar, yys);
            }
#endif
        }
        if (yychar == YYEOF) goto yyaccept;
        goto yyloop;
    }
    if (((yyn = yygindex[yym]) != 0) && (yyn += yystate) >= 0 &&
            yyn <= YYTABLESIZE && yycheck[yyn] == (YYINT) yystate)
        yystate = yytable[yyn];
    else
        yystate = yydgoto[yym];
#if YYDEBUG
    if (yydebug)
    {
        fprintf(stderr, "%s[%d]: after reduction, ", YYDEBUGSTR, yydepth);
#ifdef YYSTYPE_TOSTRING
#if YYBTYACC
        if (!yytrial)
#endif /* YYBTYACC */
            fprintf(stderr, "result is <%s>, ", YYSTYPE_TOSTRING(yystos[yystate], yyval));
#endif
        fprintf(stderr, "shifting from state %d to state %d\n", *yystack.s_mark, yystate);
    }
#endif
    if (yystack.s_mark >= yystack.s_last && yygrowstack(&yystack) == YYENOMEM) goto yyoverflow;
    *++yystack.s_mark = (YYINT) yystate;
    *++yystack.l_mark = yyval;
#if defined(YYLTYPE) || defined(YYLTYPE_IS_DECLARED)
    *++yystack.p_mark = yyloc;
#endif
    goto yyloop;
#if YYBTYACC

    /* Reduction declares that this path is valid. Set yypath and do a full parse */
yyvalid:
    if (yypath) YYABORT;
    while (yyps->save)
    {
        YYParseState *save = yyps->save;
        yyps->save = save->save;
        save->save = yypath;
        yypath = save;
    }
#if YYDEBUG
    if (yydebug)
        fprintf(stderr, "%s[%d]: state %d, CONFLICT trial successful, backtracking to state %d, %d tokens\n",
                        YYDEBUGSTR, yydepth, yystate, yypath->state, (int)(yylvp - yylvals - yypath->lexeme));
#endif
    if (yyerrctx)
    {
        yyFreeState(yyerrctx);
        yyerrctx = NULL;
    }
    yylvp          = yylvals + yypath->lexeme;
#if defined(YYLTYPE) || defined(YYLTYPE_IS_DECLARED)
    yylpp          = yylpsns + yypath->lexeme;
#endif
    yylexp         = yylexemes + yypath->lexeme;
    yychar         = YYEMPTY;
    yystack.s_mark = yystack.s_base + (yypath->yystack.s_mark - yypath->yystack.s_base);
    memcpy (yystack.s_base, yypath->yystack.s_base, (size_t) (yystack.s_mark - yystack.s_base + 1) * sizeof(YYINT));
    yystack.l_mark = yystack.l_base + (yypath->yystack.l_mark - yypath->yystack.l_base);
    memcpy (yystack.l_base, yypath->yystack.l_base, (size_t) (yystack.l_mark - yystack.l_base + 1) * sizeof(YYSTYPE));
#if defined(YYLTYPE) || defined(YYLTYPE_IS_DECLARED)
    yystack.p_mark = yystack.p_base + (yypath->yystack.p_mark - yypath->yystack.p_base);
    memcpy (yystack.p_base, yypath->yystack.p_base, (size_t) (yystack.p_mark - yystack.p_base + 1) * sizeof(YYLTYPE));
#endif
    yystate        = yypath->state;
    goto yyloop;
#endif /* YYBTYACC */

yyoverflow:
    YYERROR_CALL("yacc stack overflow");
#if YYBTYACC
    goto yyabort_nomem;
yyenomem:
    YYERROR_CALL("memory exhausted");
yyabort_nomem:
#endif /* YYBTYACC */
    yyresult = 2;
    goto yyreturn;

yyabort:
    yyresult = 1;
    goto yyreturn;

yyaccept:
#if YYBTYACC
    if (yyps->save) goto yyvalid;
#endif /* YYBTYACC */
    yyresult = 0;

yyreturn:
#if defined(YYDESTRUCT_CALL)
    if (yychar != YYEOF && yychar != YYEMPTY)
#if defined(YYLTYPE) || defined(YYLTYPE_IS_DECLARED)
        YYDESTRUCT_CALL("cleanup: discarding token", yychar, &yylval, &yylloc);
#else
        YYDESTRUCT_CALL("cleanup: discarding token", yychar, &yylval);
#endif /* defined(YYLTYPE) || defined(YYLTYPE_IS_DECLARED) */

    {
        YYSTYPE *pv;
#if defined(YYLTYPE) || defined(YYLTYPE_IS_DECLARED)
        YYLTYPE *pp;

        for (pv = yystack.l_base, pp = yystack.p_base; pv <= yystack.l_mark; ++pv, ++pp)
             YYDESTRUCT_CALL("cleanup: discarding state",
                             yystos[*(yystack.s_base + (pv - yystack.l_base))], pv, pp);
#else
        for (pv = yystack.l_base; pv <= yystack.l_mark; ++pv)
             YYDESTRUCT_CALL("cleanup: discarding state",
                             yystos[*(yystack.s_base + (pv - yystack.l_base))], pv);
#endif /* defined(YYLTYPE) || defined(YYLTYPE_IS_DECLARED) */
    }
#endif /* defined(YYDESTRUCT_CALL) */

#if YYBTYACC
    if (yyerrctx)
    {
        yyFreeState(yyerrctx);
        yyerrctx = NULL;
    }
    while (yyps)
    {
        YYParseState *save = yyps;
        yyps = save->save;
        save->save = NULL;
        yyFreeState(save);
    }
    while (yypath)
    {
        YYParseState *save = yypath;
        yypath = save->save;
        save->save = NULL;
        yyFreeState(save);
    }
#endif /* YYBTYACC */
    yyfreestack(&yystack);
    return (yyresult);
}
